dnl Process this file with "m4 -DLANG=C" or "m4 -DLANG=PERL" to generate an
dnl API document.
dnl
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<html>
<head>
<meta name="generator" content="m4 -DLANG=LANG libcoral.m4" />
<!--

  Copyright 1999, 2000, 2001, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2011, 2012, 2019 The Regents of the University of California
  All Rights Reserved 
  
  Permission to use, copy, modify and distribute any part of this
  CoralReef software package for educational, research and non-profit
  purposes, without fee, and without a written agreement is hereby
  granted, provided that the above copyright notice, this paragraph
  and the following paragraphs appear in all copies.
  
  Those desiring to incorporate this into commercial products or use
  for commercial purposes should contact the Technology Transfer
  Office, University of California, San Diego, 9500 Gilman Drive, La
  Jolla, CA 92093-0910, Ph: (858) 534-5815, FAX: (858) 534-7345.
  
  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
  PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
  DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
  THE POSSIBILITY OF SUCH DAMAGE.
  
  THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
  UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
  SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
  OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
  OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
  PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
  ANY PATENT, TRADEMARK OR OTHER RIGHTS.
  
  The CoralReef software package is developed by the CoralReef
  development team at the University of California, San Diego under
  the Cooperative Association for Internet Data Analysis (CAIDA)
  Program. Support for this effort is provided by the CAIDA grant
  NCR-9711092, DARPA NGI Contract N66001-98-2-8922, DARPA NMS Grant
  N66001-01-1-8909, and by CAIDA members.
  
  Report bugs and suggestions to coral-bugs@caida.org.
-->
<!-- $Id: libcoral.m4,v 1.129 2019/03/28 23:40:43 kkeys Exp $ -->
dnl
dnl Verify LANG.
define(usage,
    `changequote([,])errprint([LANG] must be defined as C or PERL.)m4exit()')dnl
ifdef(`LANG', , `usage')dnl
ifelse(LANG, C, , LANG, PERL, , `usage')dnl
undefine(`usage')dnl
dnl
changequote(<:,:>)dnl  use <: and :> as m4 quotes
changecom(@)dnl
dnl
dnl Rename m4 builtins that might conflict with our text.
define(m4_decr, defn(<:decr:>))dnl
define(m4_define, defn(<:define:>))dnl
define(m4_defn, defn(<:defn:>))dnl
define(m4_divert, defn(<:divert:>))dnl
define(m4_eval, defn(<:eval:>))dnl
define(m4_expr, defn(<:expr:>))dnl
define(m4_format, defn(<:format:>))dnl
define(m4_ifdef, defn(<:ifdef:>))dnl
define(m4_ifelse, defn(<:ifelse:>))dnl
define(m4_include, defn(<:include:>))dnl
define(m4_incr, defn(<:incr:>))dnl
define(m4_index, defn(<:index:>))dnl
define(m4_len, defn(<:len:>))dnl
define(m4_maketemp, defn(<:maketemp:>))dnl
define(m4_paste, defn(<:paste:>))dnl
define(m4_regexp, defn(<:regexp:>))dnl
define(m4_shift, defn(<:shift:>))dnl
define(m4_substr, defn(<:substr:>))dnl
define(m4_undefine, defn(<:undefine:>))dnl
define(m4_unix, defn(<:unix:>))dnl
dnl
dnl The basic language choice macros.
m4_define(DOC_C, m4_ifelse(LANG, C, $1))dnl
m4_define(DOC_PERL, ifelse(LANG, PERL, $1))dnl
m4_define(DOC_BOTH, ifelse(LANG, C, $1, LANG, PERL, $2))dnl
dnl
dnl Abbreviated HTML macros
m4_define(CODE, <:<code><:$1:></code>:>)dnl
m4_define(VAR, <:<var><:$1:></var>:>)dnl
dnl
dnl Convenience macros for frequently occurring text.
m4_define(DOC_LANG, DOC_BOTH(C, Perl))dnl
m4_define(DOC_name, DOC_BOTH(libcoral, Coral.pm))dnl
m4_define(DOC_Name, DOC_BOTH(Libcoral, Coral.pm))dnl
m4_define(DOC_NULL, DOC_BOTH(NULL, undef))dnl
m4_define(DOC_errno, DOC_BOTH(errno, <:$!:>))dnl
m4_define(DOC_CORAL, DOC_BOTH(CORAL_$1, $1))dnl		constant
m4_define(DOC_uint64, DOC_BOTH(uint64_t, NUM))dnl
m4_define(DOC_COM, DOC_BOTH(/* $1 */, # $1))dnl		one-line comment
m4_define(DOC_VAR, DOC_PERL($)$1)dnl			variable in sample code
m4_define(DOC_elseif, DOC_BOTH(else if,elsif))dnl
dnl
dnl DOC_LABEL(label, ...)
dnl One or more position labels
m4_define(DOC_LABEL1, <:<a name="$1" id="$1"></a>:>)dnl name for html, id for xml
m4_define(DOC_LABEL, <:m4_ifelse($#, 0, , $#, 1, <:DOC_LABEL1(<:$1:>):>,
<:DOC_LABEL1(<:$1:>)
DOC_LABEL(m4_shift($@)):>):>)dnl
dnl m4_define(DOC_LABEL, <:<a name="$1" id="$1"></a>:>)dnl name for html, id for xml
dnl
dnl
m4_define(DOC_TOC_DEPTH, 2)dnl
m4_define(DOC_NOTOC, 0)dnl
dnl
dnl DOC_TOC_INDENT(depth)
dnl Indent the HTML according to depth.  Not really necessary, but makes the
dnl generated code more readable.
m4_define(DOC_TOC_INDENT,
<:m4_ifelse(m4_eval($1<3), 1, , <:  DOC_TOC_INDENT(m4_decr($1)):>):>)
dnl
dnl DOC_SET_TOC_DEPTH(n)
dnl Change the ToC depth to n.
m4_define(DOC_SET_TOC_DEPTH, <:dnl
m4_ifelse(m4_eval($1 < DOC_TOC_DEPTH), 1, <:
DOC_TOC_INDENT(DOC_TOC_DEPTH)</ul>m4_define(<:DOC_TOC_DEPTH:>, m4_decr(DOC_TOC_DEPTH))DOC_SET_TOC_DEPTH($1):>)dnl
m4_ifelse(m4_eval($1 > DOC_TOC_DEPTH), 1, <:m4_define(<:DOC_TOC_DEPTH:>, m4_incr(DOC_TOC_DEPTH))
DOC_TOC_INDENT(DOC_TOC_DEPTH)<ul>DOC_SET_TOC_DEPTH($1):>)dnl
:>)
dnl DOC_TOC(n, text, label)
dnl Generate a label in the body, and a ToC entry at depth n pointing to it
m4_define(DOC_TOC, <:dnl
m4_divert(1)dnl
DOC_SET_TOC_DEPTH($1)dnl Open or close as many <ul>'s as needed

<font size="+1">DOC_TOC_INDENT($1)<li><::>DOC_REF($2, #$3)</font>dnl
DOC_SET_TOC_DEPTH(m4_incr($1))dnl Open a new <ul> under this heading
m4_divert(2)dnl
DOC_LABEL($3)dnl
:>)dnl
dnl
dnl DOC_HEADER(n, text, label)
dnl Generate a header in the body and in the ToC at depth n
m4_define(DOC_HEADER, <:dnl
DOC_TOC($1, $2, $3)
<h$1>$2</h$1>dnl
:>)dnl
dnl
dnl DOC_Hn(text, label)
dnl Generate an <Hn> header in the body and in the ToC
m4_define(DOC_H2, <:DOC_HEADER(2, $1, $2):>)dnl
m4_define(DOC_H3, <:DOC_HEADER(3, $1, $2):>)dnl
m4_define(DOC_H4, <:DOC_HEADER(4, $1, $2):>)dnl
dnl
dnl DOC_REF(text, url)
dnl text is a reference to url
m4_define(DOC_REF, <a href="$2">$1</a>)dnl
dnl DOC_URL(url)
m4_define(DOC_URL, <a href="$1">$1</a>)dnl
dnl DOC_OPT(name)
dnl name is a coral option
m4_define(DOC_OPT, DOC_REF(CODE(DOC_CORAL(OPT_$1)), #DOC_CORAL(OPT_$1)))dnl
dnl DOC_CMD_USAGE(text [, #ref])
dnl text is a ref to cmd_usage.html#ref
m4_define(DOC_CMD_USAGE, DOC_REF($1, cmd_usage.html$2))dnl
dnl DOC_APP(name)
dnl name is a coral application
m4_define(DOC_APP, CODE(DOC_REF($1, applications.html#$1)))dnl
dnl DOC_ID(name)
dnl name is a coral function/identifier
m4_define(DOC_ID, DOC_BOTH(coral_$1, $1))dnl
dnl DOC_IDREF(name)
dnl name is a ref to a coral function/identifier
m4_define(DOC_IDREF, DOC_REF(DOC_ID($1), #DOC_ID($1)))dnl
dnl DOC_TYPE(type)
dnl "type" is the base of a coral type name
m4_define(DOC_TYPE, DOC_BOTH(DOC_DOWNCASE(coral_$1_t), $1))dnl
dnl DOC_TYPEREF(type)
dnl a ref to a coral type
m4_define(DOC_TYPEREF, DOC_REF(DOC_TYPE($1), #DOC_TYPE($1)))dnl
dnl DOC_PROTO(name)
dnl name is a coral protocol id
m4_define(DOC_PROTO, DOC_CMD_USAGE(CODE(DOC_CORAL($1)), #protocols))dnl
dnl
dnl Examples of m4 recursion
dnl define(<:reverse:>, <:ifelse($#, 0, , $#, 1, <:<:$1:>:>,
dnl        <:reverse(shift($@)), <:$1:>:>):>)
dnl define(<:forward:>, <:ifelse($#, 0, , $#, 1, <:<:$1:>:>,
dnl        <:<:$1:>, forward(shift($@)):>):>)
dnl
dnl DOC_DECL(line)
dnl DOC_DECL(retval_and_funcname, parameters...)
dnl Formats a declaration using only html text elements, not <pre>, so it's
dnl legal to use in <dt>.  With one arg, the arg is just printed.  With >1
dnl arg (even if arg 2 is empty), arg 1 is printed, followed by args 2-N in
dnl parentheses, with line breaks where needed, followed by ";".
dnl Also generates a label and a ToC entry.
dnl
dnl Functions used internally by DOC_DECL:
dnl DOC_DECL_TEXT() formats retval_and_funcname, making the funcname bold
dnl DOC_PARAMS() formats a function's parameter list
dnl DOC_PARAM_BREAK(len, param...) inserts line break if needed before param
dnl DOC_NEED_WRAP(len, str) decides if str can fit on a line that already has
dnl   len characters in it.
dnl DOC_TEXTLEN(str) calculates the length of str, not counting html tags.
m4_define(DOC_WIDTH, 79)dnl
dnl Translate parens first to avoid nasty quoting problems
m4_define(DOC_TEXTLEN, <:DOC_TEXTLEN_(translit(<:$1:>, <:():>, <:[]:>)):>)dnl
m4_define(DOC_TEXTLEN_,
<:m4_define(<:_start:>, m4_index(<:$1:>, <)):>dnl
<:m4_define(<:_end:>, m4_index(<:$1:>, >)):>dnl
<:m4_ifelse(<:$1:>, <::>, 0,dnl broken len() returns null instead of 0 for null arg
_start, -1, <:m4_len(<:$1:>):>,dnl
<:m4_eval(_start + DOC_TEXTLEN_(m4_substr(<:$1:>, m4_eval(_end + 1)))):>):>dnl
<:m4_undefine(<:_start:>):>
<:m4_undefine(<:_end:>):>
)dnl
dnl
m4_define(DOC_NEED_WRAP, <:m4_eval($1 + DOC_TEXTLEN($2) > DOC_WIDTH):>)dnl
m4_define(DOC_PARAM_BREAK, <:m4_ifelse(DOC_NEED_WRAP($1, <:$2:>), 1, <:<:,:><br />
    &nbsp;&nbsp;&nbsp; :>, <:<:,:>
    :>):>)dnl
m4_define(DOC_PARAMS,
    <:m4_ifelse(<:$2:>, <::>, <::>,
	$#, 2, <:DOC_PARAM_BREAK($@)<:<:$2:>:>:>,
       <:DOC_PARAM_BREAK($@)<:<:$2:>:>DOC_PARAMS(m4_eval(m4_ifelse(DOC_NEED_WRAP($1, <:$2:>), 1, 2, $1) + 2 + DOC_TEXTLEN(<:$2:>)), m4_shift(m4_shift($@))):>):>)dnl
dnl
ifdef(<:__gnu__:>, dnl
<: dnl gnu version, with \( \| \)
m4_define(DOC_DECL_TEXT,
    <:m4_regexp(<:$1:>,
    <:\(^.*[^a-zA-Z0-9_<>/]\|^\)\([a-zA-Z0-9_<>/]+\)\([^a-zA-Z0-9_<>/]*\)$:>,
    <:\1<b>\2</b>\3:>):>)dnl
m4_define(DOC_DECL_NAME,
    <:m4_regexp(<:$1:>,
    <:\(^.*[^a-zA-Z0-9_<>/]\|^\)\([a-zA-Z0-9_<>/]+\)\([^a-zA-Z0-9_<>/]*\)$:>,
    <:\2:>):>):>,dnl
<: dnl freebsd version, with ( | )
m4_define(DOC_DECL_TEXT,
    <:m4_regexp(<:$1:>,
    <:(^.*[^a-zA-Z0-9_<>/]|^)([a-zA-Z0-9_<>/]+)([^a-zA-Z0-9_<>/]*)$:>,
    <:\1<b>\2</b>\3:>):>)dnl
m4_define(DOC_DECL_NAME,
    <:m4_regexp(<:$1:>,
    <:(^.*[^a-zA-Z0-9_<>/]|^)([a-zA-Z0-9_<>/]+)([^a-zA-Z0-9_<>/]*)$:>,
    <:\2:>):>):>)dnl
dnl
m4_define(DOC_DECL, <:dnl
m4_ifelse(m4_eval(DOC_NOTOC > 0), 1, ,
<:m4_divert(1)dnl
m4_ifelse(DOC_DECL_FIRST, 1, m4_define(<:DOC_DECL_FIRST:>, 0), <:,
DOC_TOC_INDENT(m4_incr(DOC_TOC_DEPTH))  :>)dnl
DOC_REF(<code>DOC_DECL_NAME(<:$1:>)</code>, #DOC_DECL_NAME(<:$1:>))dnl
m4_divert(2):>)dnl
DOC_LABEL(DOC_DECL_NAME(<:$1:>))
<font size="+1">m4_ifelse($#, 1, DOC_DECL_TEXT(<:$1:>),
DOC_DECL_TEXT(<:$1:>)<:(<:$2:>:>DOC_PARAMS(DOC_TEXTLEN(<:$1.$2:>), m4_shift(m4_shift($@)))<:);:>)</font><br />:>)dnl
dnl
dnl DOC_ENTRY(c_entry, perl_entry)
dnl format a function entry
m4_define(DOC_ENTRY, <:dnl
m4_ifelse(m4_eval(DOC_NOTOC > 0), 1, ,
<:m4_divert(1)
m4_define(<:DOC_DECL_FIRST:>, 1)dnl
DOC_TOC_INDENT(DOC_TOC_DEPTH)<li>dnl
m4_divert(2):>)dnl
<dt>
<code>
DOC_BOTH(<:$1:>,<:$2:>)
</code>
<dd>:>)dnl
dnl
m4_define(DOC_ENTRY_NOTOC, <:dnl
m4_define(<:DOC_NOTOC:>, m4_incr(DOC_NOTOC))dnl
DOC_ENTRY($1, $2)
m4_define(<:DOC_NOTOC:>, m4_decr(DOC_NOTOC))dnl
:>)dnl
dnl
dnl
dnl utilities
m4_define(DOC_DOWNCASE, <:translit($1, ABCDEFGHIJKLMNOPQRSTUVWXYZ, abcdefghijklmnopqrstuvwxyz):>)dnl
dnl
dnl Get rid of m4 builtins that might conflict with our text.
undefine(<:decr:>)dnl
undefine(<:define:>)dnl
undefine(<:defn:>)dnl
undefine(<:divert:>)dnl
undefine(<:eval:>)dnl
undefine(<:expr:>)dnl
undefine(<:format:>)dnl
undefine(<:ifdef:>)dnl
undefine(<:ifelse:>)dnl
undefine(<:include:>)dnl
undefine(<:incr:>)dnl
undefine(<:index:>)dnl
undefine(<:len:>)dnl
undefine(<:maketemp:>)dnl
undefine(<:paste:>)dnl
undefine(<:regexp:>)dnl
undefine(<:shift:>)dnl
undefine(<:substr:>)dnl
undefine(<:unix:>)dnl
dnl
dnl undefine(<:undefine:>)dnl
dnl
dnl
m4_divert(0)
  <title>Documentation for the DOC_LANG Coral API</title>
</head>

<body>
<h1>DOC_name - a DOC_LANG API for CoralReef</h1>

m4_divert(1)<ul>dnl Table of Contents
m4_divert(2)dnl body

DOC_H2(Introduction, intro)
DOC_Name provides a DOC_LANG API for reading network interface devices
and several different trace
file formats, and for writing trace files.
DOC_C(The installed <b>Coral/lib/example</b> directory contains an example
application and Makefile that will help you get started writing your own code.
Other realistic examples of libcoral use can be found in apps/utils/*.c
in the distribution.)
DOC_PERL(<:
It is mostly a wrapper for calls to DOC_REF(libcoral, libcoral-c.html),
with some additional Perl-centric structures when appropriate.
:>)
<p>
Libcoral operates on "sources", which include several types of
live network interfaces/devices, and several types of tracefiles containing
data recorded from one or more network interfaces/devices.
The naming scheme for sources is described in the
DOC_CMD_USAGE(command usage document, #sourcenames).
</p>
<p>
A typical program using DOC_name has this basic structure:
</p>
<pre>
  DOC_REF(configure, #DOC_ID(config)) DOC_name and one or more sources
  DOC_REF(open, #DOC_ID(open)) sources
  DOC_REF(start, #DOC_ID(start)) sources
  while (read DOC_C(<:block, :>)cell or packet != DOC_NULL) {
      process the data we just read
      if (stop condition occurs) {
	  DOC_REF(stop, #DOC_ID(stop)) sources
      }
  }
  DOC_REF(close, #DOC_ID(close)) sources
</pre>
<p>
DOC_PERL(<:All identifiers defined in this document are in the CODE(Coral)
namespace, and are not exportable.  Therefore, all methods must be fully
qualified, e.g.:  Coral::quick_start().<p>:>)
In the descriptions below, there are several pairs of functions with the same
base name, with or without an "_all" suffix.
The function suffixed with "_all" operates on
all sources, and the other one operates on a single source indicated by
the VAR(src) parameter.
</p>

DOC_C(<:
DOC_H3(Compiling C and C++, compiling)
<p>
All C/C++ programs built on CoralReef should include these headers:
</p>
<pre>
#include &lt;stdlib.h&gt;
#include &lt;stdio.h&gt;
#include &lt;sys/param.h&gt;
#include &lt;libcoral.h&gt;
</pre>
<p>
Note that CODE(&lt;libcoral.h&gt;) will define
DOC_REF(fixed-width integer types, #uint32_t)
(like CODE(uint32_t)) if your system does not, since they are needed
by many libcoral structures.
</p>
<p>
The following optional headers are also available:
</p>
<pre>
#include &lt;coral-config.h&gt; /* configuration information used by coral */
#include &lt;DOC_REF(crl_byteorder, #byteorder).h&gt; /* byte order macros */
</pre>
<p>
CoralReef programs should link with CODE(-lcoral),
CODE(-lpcap) (if libcoral was compiled with pcap support),
CODE(-lz) (if libcoral was compiled with zlib support), and
possibly CODE(-lstdc++) (if needed for DOC_REF(Crypto-PAn, #anon)),
in that order.
The installed <b>Coral/lib/example/Makefile</b> will link with the correct
set of libraries.
</p>
:>)

DOC_PERL(<:
DOC_H3(Note on 'Prototypes', legend)
The types and prototypes listed in the class definitions and function parameters
vary somewhat from standard Perl form.  When possible, instead of
merely calling types 'SCALAR' or 'LIST', additional information has been
given as to the type of the parameter.  Optional parameters are followed
by "=" and their default value.  Examples of types:
<dl>
    <dt>BOOL
	<dd>A Boolean (true/false) value.  Usually 1 or 0.
    <dt>STR
	<dd>A string value.
    <dt>NUM
	<dd>A number (integer or floating point) value.
    <dt>LIST REF
	<dd>A reference to a list.
    <dt>STR REF
	<dd>A reference to a string.
    <dt>SomeClass
	<dd>A blessed reference to one of the
	DOC_REF(classes, #classes) used by Coral.
    <dt>SCALAR
	<dd>An opaque object, never accessed directly by the user.
	Usually returned by a function call.  For example, the
	timestamp in the DOC_TYPEREF(Cell) or
	DOC_TYPEREF(Pkt_buffer) classes, which is read by
	the DOC_IDREF(read_clock) functions, or
	a source or interface returned by the
	DOC_IDREF(next_source) or
	DOC_IDREF(next_interface) functions.
</dl>
Also, the 'FILEHANDLE' types must be attached to an actual stdio FILE.
:>)

DOC_H2(The API, api)

DOC_PERL(<:
DOC_H3(Quick Start, quickstart)
<dl>
DOC_ENTRY(,<:
DOC_DECL(quick_start, BOOL time_sort = 0, BOOL partial_pkt = 1, NUM api = DOC_CORAL(API_PKT))
:>)
<p>
This Perl-only function does the configuration and startup for
most common cases of CRL use.  If finer control is needed, use the 
DOC_REF(command line configuration, #user-config) and
DOC_REF(global configuration, #prog-config)
functions below.
If VAR(time_sort) equals 1, cells/packets will be sorted, otherwise they will not.
If VAR(partial_pkt) equals 0, then truncated packets are discarded by
DOC_IDREF(read_pkt)(), otherwise they are accepted.
VAR(Api) allows the user to set the libcoral API being used; the default is
DOC_CORAL(API_PKT).
</p>
<p>
To limit the number of sources that will be allowed, call
CODE(DOC_IDREF(set_max_sources)())
before calling this function.
</p>
<p>
This function returns nothing.
If any fatal errors are encountered, it exits.
</p>
<p>
The code consists of:
</p>
<pre>
sub quick_start {
    my ($time_sort, $partial_pkt, $api) = @_;

    if (defined $time_sort and $time_sort != 0) {
	if (Coral::DOC_IDREF(set_options)(0, $Coral::DOC_OPT(SORT_TIME)) &lt; 0) {
	    Coral::DOC_IDREF(puts)("Warning: could not set time-sorting option!");
	}
    } elsif (Coral::DOC_IDREF(set_options)($Coral::DOC_OPT(SORT_TIME), 0) &lt; 0) {
	Coral::DOC_IDREF(puts)("Warning: could not unset time-sorting option!");
    }

    if (defined $partial_pkt and $partial_pkt == 0) {
	if (Coral::DOC_IDREF(set_options)($Coral::DOC_OPT(PARTIAL_PKT), 0) &lt; 0) {
	    Coral::DOC_IDREF(puts)("Warning: could not unset partial packeting option!");
	}
    } elsif (Coral::DOC_IDREF(set_options)(0, $Coral::DOC_OPT(PARTIAL_PKT)) &lt; 0) {
	Coral::DOC_IDREF(puts)("Warning: could not set partial packeting option!");
    }

    if (defined $api) {
	if (Coral::DOC_IDREF(set_api)($api) &lt; 0) {
	    Coral::DOC_IDREF(puts)("Warning: could not specify api!");
	}
    } elsif (Coral::DOC_IDREF(set_api)($Coral::DOC_ID(API_PKT)) &lt; 0) {
	Coral::DOC_IDREF(puts)("Warning: could not specify packet api!");
    }

    if (Coral::DOC_IDREF(config_arguments)(scalar(@ARGV), \@ARGV) &lt; 0) {
	Coral::DOC_IDREF(puts)("Error: could not parse command-line options!");
	exit(1);
    }
    if (Coral::DOC_IDREF(open_all)() &lt;= 0) { # no openable sources is considered an error
	Coral::DOC_IDREF(puts)("Error: could not open any sources!");
	exit(1);
    }
    if (Coral::DOC_IDREF(start_all)() &lt; 0) {
	Coral::DOC_IDREF(puts)("Error: could not start any sources!");
	exit(1);
    }
}
</pre>
</dl>
:>) dnl DOC_PERL

DOC_LABEL(DOC_ID(config), user-config)
DOC_H3(Command-line Configuration, DOC_ID(config))
<p>
The following functions read coral commands from the command line or
config files.  The coral commands are described in the
DOC_CMD_USAGE(command usage document).
These functions should only be called before
DOC_IDREF(open)() or
DOC_IDREF(open_all)().
</p>
<p>
You should call DOC_IDREF(set_api)()
before calling these functions to enable certain configuration commands.
Also, you should set the defaults for configurable values with the
DOC_IDREF(set) functions before calling any of these
functions, and (if needed) get the value after.
This way, the option and its default value will appear in the
CODE(DOC_IDREF(usage)()) message, and the user can override the
defaults with command line options.  If your application does not use a
particular configurable value, you should leave it set to its initial value,
so it will not appear in the CODE(DOC_IDREF(usage)()) message,
and the DOC_IDREF(config) functions will not allow it
to be changed on the command line.
</p>

<dl>


DOC_ENTRY(<:
DOC_DECL(int coral_config_arguments, int argc, char *argv[])
:>,<:
DOC_DECL(config_arguments, NUM argc, LIST REF argv)
:>)
<p>
This function processes "CODE(-C)" options and sourcename arguments
contained in VAR(argv).
VAR(Argv) is a DOC_BOTH(pointer to an array, reference to a list)
of strings containing the command line;
VAR(argc) is the number of strings in VAR(argv).
For a description of Coral options, see the
DOC_CMD_USAGE(Command Usage documentation).
A CoralReef source is created (with CODE(DOC_IDREF(new_source)()))
from each sourcename argument.
If an option syntax error is encountered, this function prints a usage message.
If other arguments are desired, use
CODE(DOC_IDREF(config_options)()) instead
and parse the arguments yourself;
if other options are desired, parse the options and arguments yourself and call 
CODE(DOC_IDREF(config_command)())
for each "CODE(-C)" option.
Returns a non-negative integer for success, -1 for failure.
</p>
<p>
To limit the number of sources that will be allowed, call
CODE(DOC_IDREF(set_max_sources)())
before calling this function.
</p>
<p>
DOC_BOTH(
<:For an example, see the DOC_REF(end of this section, #user-config-ex2).:>,
<:Sample call: CODE($nxt_idx = DOC_IDREF(config_options)<:(scalar(@ARGV),
\@ARGV, "&lt;outputfile&gt;");:>):>
)
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_config_options, int argc, char *argv[],
    const char *argmsg)
:>,<:
DOC_DECL(config_options, NUM argc, LIST REF argv, STR argmsg)
:>)
<p>
This function is like CODE(DOC_IDREF(config_arguments)()), except it
processes only the options, not the non-option arguments.
If VAR(argmsg) is CODE(DOC_NULL), this
function assumes that arguments (other than Coral options) are not allowed,
and considers it an error if other arguments are found;
otherwise, other arguments (but not other options) are allowed.
If successful, this function returns the index of the first non-option
argument<::>DOC_C(<: (so it would return 1 if there were no options,
since CODE(argv[0]) is the application name):>).
It is the programmer's responsibility to handle
the remaining command line arguments.
If an error is encountered, this function returns -1, and prints a usage message
with CODE(DOC_IDREF(usage)DOC_BOTH(
    <:(argv[0], "%s", VAR(argmsg)):>,
    <:($0, VAR(argmsg)):>)).
If other options are desired, use CODE(DOC_IDREF(config_command)()) instead.
Returns a non-negative integer for success, -1 for failure.
</p>
DOC_PERL(
    <:<p>
    Sample call: CODE($nxt_idx = DOC_IDREF(config_options)<:(scalar(@ARGV),
    \@ARGV, "&lt;outputfile&gt;");:>)
    </p>:>
)dnl


DOC_ENTRY(<:
DOC_DECL(int coral_config_command, const char *command)
:>,<:
DOC_DECL(config_command, STR command, STR filename, NUM linenum)
:>)
<p>
Processes a config command.  This function should be used instead of
CODE(DOC_IDREF(config_options)()) or CODE(DOC_IDREF(config_arguments)())
if you need to accept your own options in addition to CoralReef options,
or you want to accept CoralReef commands from inputs other than the command line.
DOC_PERL(
<:VAR(Filename) and VAR(linenum) are printed in error
messages; pass undef and 0 to have them not printed.:>
)dnl
Returns 0 for success, -1 for failure.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_config_file, const char *filename)
:>,<:
DOC_DECL(config_file, STR filename)
:>)
<p>
Process CoralReef commands in file VAR(filename).
This is not usually needed if CODE(DOC_IDREF(config_arguments)()),
CODE(DOC_IDREF(config_options)()), or CODE(DOC_IDREF(config_command)())
is used.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_usage, const char *appname, const char *argmsg, ...)
:>,<:
DOC_DECL(usage, STR appname, STR argmsg = undef)
:>)
<p>
Prints a message describing the command line syntax of a CoralReef application
named VAR(appname).
DOC_BOTH(
<:If VAR(argmsg) is not CODE(DOC_NULL),
it is used as a printf-style format for the arguments that follow,
and the formatted result is appended to the syntax line.:>,
<:If VAR(argmsg) is not undef, it is appended to the syntax line.:>
)
This is followed by descriptions of the CoralReef (-C) command line options.
</p>
<p>
Some example values for VAR(argmsg):
</p>
    <dl>
    <dt>for an application that takes CoralReef options and no arguments:
	<dd>CODE(DOC_NULL)
    <dt>for an application that takes CoralReef options and an optional argument
	<dd>CODE("[&lt;argument&gt;]")
    <dt>for an application that takes -f, -b<var>N</var>, and CoralReef options,
    and one or more VAR(source) arguments:
	<dd>CODE("[-f] [-b&lt;N&gt;] &lt;source&gt;...")
    </dl>

</dl>

DOC_H4(Examples, user-config-ex)
DOC_C(<:
All these examples assume you will be using the
DOC_REF(packet API, #packet); you should change the argument of
DOC_IDREF(set_api)() as needed.
<p>
DOC_LABEL(user-config-ex1)
If only CoralReef options and sourcename arguments are needed,
this simple code will do:
</p>
<pre>
    DOC_IDREF(set_api)(DOC_CORAL(API_PKT));
    if (DOC_IDREF(config_arguments)(argc, argv) &lt; 0)
        exit(-1);
</pre>

DOC_LABEL(user-config-ex2)
If other options are desired, you must parse the options and arguments yourself,
like this:
<pre>
    int opt, foo_flag = 0, bar = 42;
    extern char *optarg;
    extern int optind;

    DOC_IDREF(set_api)(DOC_CORAL(API_PKT));

    while ((opt = getopt(argc, argv, "C:fb:")) != -1) {
        switch (opt) {
        case 'C':
            if (DOC_IDREF(config_command)(optarg) &lt; 0)
                exit(-1);
            break;
        case 'f':
            foo_flag = 1;
            break;
        case 'b':
            bar = atoi(optarg);
            break;
        default:
            DOC_IDREF(usage)(argv[0], "[-f] [-b&lt;N&gt;] &lt;source&gt;...\n"
		"-f      foo flag\n"
		"-b&lt;n&gt;   bar value (default %d)\n",
		bar);
            exit(-1);
        }
    }

    while (optind &lt; argc) {
        if (!DOC_IDREF(new_source)(argv[optind]))
            exit(-1);
        optind++;
    }
</pre>
If a bad option is given, this code will print a message like this to stderr,
followed by descriptions of the CoralReef commands that are allowed for the
configured API:
<pre>
    CODE(Usage: VAR(app) [-C &lt;coral_command&gt;]... [-f] [-b&lt;N&gt;] &lt;source&gt;...)
</pre>
:>)dnl
DOC_PERL(<:
    If only Coral options and filename arguments are needed,
    this simple code will do:
    <pre>
	Coral::DOC_IDREF(quick_start)(0); # or 1 for time-sorting
    </pre>
    followed by the read_cell routines.

    If other options are desired, you must parse the options
    and arguments yourself.

    If a bad option is given, this code will print a message
    like this to stderr, followed by descriptions of the Coral
    commands:
    <pre>
      CODE(Usage: VAR(app) [-C &lt;command&gt;]... &lt;source&gt;)
    </pre>
:>)dnl

DOC_LABEL(DOC_ID(set), DOC_ID(get), prog-config)
DOC_H3(Global Configuration, prog-config)
<p>
The following functions provide a way for the programmer to set global
configuration values, including default values for the configuration of
sources that have not yet been defined.
The CODE(DOC_IDREF(set)) functions can be called
before the CODE(DOC_IDREF(config)) functions to set default
values that can be overridden on the command line or config file, and will
be displayed in the CODE(DOC_IDREF(usage)) message.
If the integer configuration values are set to a negative value,
they will not be displayed in the CODE(DOC_IDREF(usage)) message.
The CODE(DOC_IDREF(set)) functions can also be called
after the CODE(DOC_IDREF(config)) functions
so their values can't be overridden.
They must not be called after sources are opened.
The CODE(DOC_IDREF(set)) functions return 0 if successful, or -1 for failure;
the CODE(DOC_IDREF(get)) functions return the value of the requested datum.
</p>

<dl>


DOC_ENTRY(<:
DOC_DECL(void coral_config_defaults, void)
:>,<:
DOC_DECL(config_defaults, )
:>)
<p>
Resets libcoral configuration to its default state.  Should not be called
while sources are open.
The affected configuration values are:
DOC_REF(max_sources, #DOC_ID(set_max_sources)),
DOC_REF(options, #DOC_ID(set_options)),
DOC_REF(duration, #DOC_ID(set_duration)),
DOC_REF(interval, #DOC_ID(set_interval)),
DOC_REF(dropinterval, #DOC_ID(set_dropinterval)),
DOC_REF(mintime, #DOC_ID(set_mintime)),
DOC_REF(maxtime, #DOC_ID(set_maxtime)),
DOC_REF(errfile, #DOC_ID(set_errfile)),
dnl DOC_REF(filetime, #DOC_ID(set_filetime)),
DOC_REF(iomode, #DOC_ID(set_iomode)),
DOC_REF(comment, #DOC_ID(set_comment)),
DOC_REF(gzip level, #DOC_ID(set_gzip)),
DOC_REF(pcap filter, #DOC_ID(add_pcap_filter)),
DOC_REF(api, #DOC_ID(set_api)),
DOC_REF(max_blks, #DOC_ID(set_max_blks)),
DOC_REF(max_cells, #DOC_ID(set_max_cells)),
DOC_REF(max_pkts, #DOC_ID(set_max_pkts)),
DOC_REF(skip_pkts, #DOC_ID(set_skip_pkts)),
DOC_CMD_USAGE(bandwidth, #bw),
DOC_CMD_USAGE(physical protocol, #phy),
DOC_CMD_USAGE(datalink protocol, #proto),
DOC_REF(firmware, #DOC_ID(set_firmware)).
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_api, int api)
:>,<:
DOC_DECL(set_api, NUM api)
:>)
<p>
The VAR(api) parameter to CODE(DOC_IDREF(set_api)()) must be
DOC_C(CODE(DOC_REF(DOC_CORAL(API_BLOCK), #coral_read_block))<:,
:>)dnl
CODE(DOC_REF(DOC_CORAL(API_CELL), #cell)), or
CODE(DOC_REF(DOC_CORAL(API_PKT), #packet)),
optionally bitwise ORed with
CODE(DOC_REF(DOC_CORAL(API_WRITE), #DOC_ID(write))).
It initializes libcoral for use with the corresponding APIs,
and should be called before any coral config, reading, or writing function.
</p>
<p>
Setting the APIs enables command line and configuration file options
and functions that are specific to those APIs.  DOC_Name will generate
an error if any disallowed option or function is attempted.
</p>
<p>
The VAR(api) parameter should contain exactly one of the following
constants:
</p>
<table border="1">
<tr><td>API
    <td>allowed DOC_CMD_USAGE(configuration commands, #config_commands)
    <td>allowed functions
<tr><td>
DOC_C(
<tr><td>CODE(DOC_REF(DOC_CORAL(API_BLOCK), #coral_read_block))
    <td>
    CODE(DOC_CMD_USAGE(blocks, #blocks))
    <td>
)dnl
<tr><td>CODE(DOC_REF(DOC_CORAL(API_CELL), #cell))
    <td>
    CODE(DOC_CMD_USAGE(cells, #cells))
    CODE(DOC_CMD_USAGE(blocks, #blocks))
    CODE(DOC_CMD_USAGE(deny, #deny))
    <td>
<tr><td>CODE(DOC_REF(DOC_CORAL(API_PKT), #packet))
    <td>
    CODE(DOC_CMD_USAGE(packets, #packets))
    CODE(DOC_CMD_USAGE(filter, #filter))
    CODE(DOC_CMD_USAGE(deny, #deny))
    <td>
    CODE(DOC_IDREF(add_pcap_filter)())
</table>
<p>
Commands and functions not listed under any API are valid for all APIs.
</p>
<p>
The VAR(api) parameter may optionally be bitwise-ORed with this
constant, if DOC_IDREF(write) or a
DOC_REF(rotating output file, #DOC_ID(rotfile)) will be used:
</p>
<table border="1">
<tr><td>API
    <td>allowed DOC_CMD_USAGE(configuration commands, #config_commands)
    <td>allowed functions
<tr><td>
<tr><td>CODE(DOC_REF(DOC_CORAL(API_WRITE), #DOC_ID(write)))
    <td>
    CODE(DOC_CMD_USAGE(gzip, #gzip))
    <td>
    CODE(DOC_IDREF(set_gzip)())
</table>
<p>
Example:  CODE(DOC_ID(set_api)(DOC_CORAL(API_PKT) | DOC_CORAL(API_WRITE));)
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_max_sources, int n)
DOC_DECL(int coral_get_max_sources, void)
:>,<:
DOC_DECL(set_max_sources, NUM n)
DOC_DECL(get_max_sources,)
:>)
<p>
CODE(DOC_IDREF(set_max_sources)()) sets the maximum number of allowed Coral
sources to VAR(n).  It should be called before
CODE(DOC_IDREF(config_arguments)()),
CODE(DOC_IDREF(config_options)()),
CODE(DOC_IDREF(config_command)()), and
CODE(DOC_IDREF(new_source)())
to restrict them.
It returns 0 if successful,
or -1 if VAR(n) is negative or greater than 16.
CODE(DOC_IDREF(get_max_sources)()) returns the maximum number of allowed Coral
sources.
The default max_sources value is 16.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_options, int off, int on)
DOC_DECL(int coral_get_options, void)
:>,<:
DOC_DECL(set_options, NUM off, NUM on)
DOC_DECL(get_options,)
:>)
<p>
CODE(DOC_IDREF(set_options)()) disables the options in the bitmask
VAR(off) and enables the options in the bitmask VAR(on).
CODE(DOC_IDREF(get_options)()) returns a bitmask of currently enabled options.
The options are:
</p>
<dl>
<dt>DOC_LABEL(DOC_CORAL(OPT_SORT_TIME))
    CODE(DOC_CORAL(OPT_SORT_TIME)) DOC_BOTH(
    <:(default: off):>,
    <:(default: off, unless DOC_IDREF(quick_start)(1) is used.):>)
    <dd>Makes CODE(DOC_IDREF(read_cell_all)()) and CODE(DOC_IDREF(read_pkt)())
    read in timestamp order.
    For this option to make sense, one of the following must be true:
    all interfaces have start epochs and were started at the same time, or
    all interfaces have unix epochs, or
    the DOC_OPT(NORMALIZE_TIME)
    option is on.
    If none of these conditions is true, libcoral will automatically enable the
    DOC_OPT(NORMALIZE_TIME)
    option.
    If your application requires time sorting, set this option before
    the command-line CODE(DOC_IDREF(config)) functions so
    "DOC_CMD_USAGE(sort, #sort)"
    will not appear in the DOC_IDREF(usage) message.
<dt>DOC_LABEL(DOC_CORAL(OPT_ALIGNINT))
    CODE(DOC_CORAL(OPT_ALIGNINT)) (default: off)
    <dd>Aligns end of first DOC_REF(interval, #interval) to a multiple of the
    interval length.
<dt>DOC_LABEL(DOC_CORAL(OPT_PARTIAL_PKT))
    CODE(DOC_CORAL(OPT_PARTIAL_PKT)) (default: on)
    <dd>Allows CODE(DOC_IDREF(read_pkt)())
    DOC_C(and CODE(DOC_IDREF(read_pkts)()))
    to handle partial packets.
<dt>DOC_LABEL(DOC_CORAL(OPT_FATM_RAW_TIME))
    CODE(DOC_CORAL(OPT_FATM_RAW_TIME)) (default: off)
    <dd>Do not attempt to automatically correct the delayed firmware clock
    increment when the hardware clock wraps in the fatm card
    or skip cells prior to a clock reset in the first block.
    This can be used to improve performance
    if cell/packet timestamps will not be needed.
<dt>DOC_LABEL(DOC_CORAL(OPT_POINT_RAW_TIME))
    CODE(DOC_CORAL(OPT_POINT_RAW_TIME)) (default: off)
    <dd>Do not attempt to automatically skip cells prior to a clock reset
    in the first block.
    This can be used to improve performance
    if cell/packet timestamps will not be needed.
<dt>DOC_LABEL(DOC_CORAL(OPT_RAW_TIME))
    CODE(DOC_CORAL(OPT_RAW_TIME))
    <dd>Equivalent to
    CODE((DOC_OPT(FATM_RAW_TIME) | DOC_OPT(POINT_RAW_TIME))).
<dt>DOC_LABEL(DOC_CORAL(OPT_NORMALIZE_TIME))
    CODE(DOC_CORAL(OPT_NORMALIZE_TIME)) (default: on)
    <dd>Make the result of the DOC_IDREF(read_clock)
    relative to the unix epoch (1970-01-01 00:00:00 UTC);
    otherwise, the result will have some interface-dependent epoch.
    Normalizing is necessary when comparing times from multiple interfaces
    (this includes using DOC_OPT(SORT_TIME))
    with different default epochs.
    But normalizing may introduce inaccuracy if
    the interfaces' hosts' CPU clocks are inaccurate,
    and may introduce additional processing overhead.
    The default epochs for the various types of interfaces are:
    <dl compact="compact">
    <dt>DOC_CMD_USAGE(fatm, #fatm)
	<dd>time of reset (e.g., by CODE(DOC_IDREF(start_all))());
    <dt>DOC_CMD_USAGE(point, #point)
	<dd>time of reset (e.g., by CODE(DOC_IDREF(start_all))());
    <dt>DOC_CMD_USAGE(dag, #dag)
	<dd>the unix epoch (of the CPU used to do the capture)
    <dt>DOC_CMD_USAGE(pcap, #pcaplive)
	<dd>the unix epoch (of the CPU used to do the capture)
    <dt>DOC_CMD_USAGE(tsh, #tsh)
	<dd>either the unix epoch or the time of reset, depending
	on the original source of data (libcoral can identify the
	epoch automatically)
    </dl>
    Traces from interfaces that don't natively use the unix epoch can only
    be normalized if the capture time was recorded in the trace.
    DOC_CMD_USAGE(NLANR and MCI .crl traces, #nlanr)
    do not contain capture time, although
    their filenames sometimes do, and CoralReef can use that;
    DOC_CMD_USAGE(.crl traces, #crl) made with CoralReef prior to 3.2.1
    contain capture time only to the nearest second.
    Traces in DOC_CMD_USAGE(.tsh format, #tsh)
    do not explicitly contain the capture time,
    but if the data timestamps are relative to the unix epoch, libcoral
    will use the first timestamp as the capture time; otherwise, libcoral
    will infer a capture time from the filename if possible.
<dt>DOC_LABEL(DOC_CORAL(OPT_NO_FILTER))
    CODE(DOC_CORAL(OPT_NO_FILTER)) (default: off)
    <dd>Do not allow a pcap filter to be set by the
    DOC_IDREF(config) functions.  This is useful
    for applications that need to define their own filters.
<dt>DOC_LABEL(DOC_CORAL(OPT_IP_CKSUM))
    CODE(DOC_CORAL(OPT_IP_CKSUM)) (default: off)
    <dd>Tells CODE(DOC_IDREF(fmt_get_payload)())
    to print and verify IP checksums.
<dt>DOC_LABEL(DOC_CORAL(OPT_IP_EXTHDR))
    CODE(DOC_CORAL(OPT_IP_EXTHDR)) (default: off)
    <dd>Tells CODE(DOC_IDREF(get_payload)())
    to not skip IP extension headers.
<dt>DOC_LABEL(DOC_CORAL(OPT_IGNORE_TIME_ERR))
    CODE(DOC_CORAL(OPT_IGNORE_TIME_ERR)) (default: off)
    <dd>By default, libcoral reading functions return an error when they
    encounter a timestamp error they can not correct in a source.
    With this option enabled, libcoral will continue reading normally,
    but beware that intervals and duration may not work correctly.
<dt>DOC_LABEL(DOC_CORAL(OPT_NO_AUTOROTATE_ERRFILE))
    CODE(DOC_CORAL(OPT_NO_AUTOROTATE_ERRFILE)) (default: off)
    <dd>By default, an DOC_REF(error file, #DOC_ID(set_errfilename))
    whose name contains "%" is rotated at the beginning of intervals.
    With this option turned on, automatic rotation is disabled.
</dl>
<p>
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_iomode, unsigned off, unsigned on, int first, int fixed)
:>,<:
DOC_DECL(set_iomode, NUM off, NUM on, NUM first = -1, BOOL fixed = 0)
:>)
<p>
This function sets the default I/O mode of all subsequently defined sources.
(To set the I/O mode of sources that have already been defined, use
CODE(DOC_IDREF(source_set_iomode)()).)
</p>
<p>
The arguments to this function are:
</p>
    <dl>
    <dt>VAR(off)
        <dd>bitmask of I/O mode flags to disable.
    <dt>VAR(on)
        <dd>bitmask of I/O mode flags to enable.
    <dt>VAR(first)DOC_PERL(<: (defaults to -1):>)
        <dd>specifies how many bytes to
	capture from each PDU (layer 2 packet/frame).
        If this parameter is negative, the configured value will be unchanged.
	For ATM interfaces, VAR(first) will be rounded up to a multiple
	of ATM cell payload size (48 bytes).
	(In versions prior to 3.2, VAR(first) was interpreted as cells
	instead of bytes on ATM interfaces.)
    <dt>VAR(fixed)DOC_PERL(<: (defaults to false):>)
	<dd>flag that prevents user from modifying the iomode via the command
	line or config file (this should be used before the
	CODE(DOC_IDREF(config)) functions, in applications
	with a non-configurable iomode).
    </dl>
<p>
The I/O mode flags are:
</p>
    <table border="1">
    <tr><td>flag
	<td>equivalent DOC_CMD_USAGE(CLI iomode, #iomode)
	<td>description
    <tr><td>
    <tr><td>DOC_CORAL(TX)
	<td>DOC_CMD_USAGE(tx, #tx)
    	<td>allow transmitting (not implemented)
    <tr><td>DOC_CORAL(RX)
	<td>DOC_CMD_USAGE(rx, #rx)
    	<td>allow receiving
    <tr><td>DOC_CORAL(RX_IDLE)
	<td>DOC_CMD_USAGE(idle, #idle)
	<td>read all cells, including ATM idle cells
    <tr><td>DOC_CORAL(RX_OAM)
	<td>DOC_CMD_USAGE(ctrl, #ctrl)
	<td>read ATM OAM/RM cells
    <tr><td>DOC_CORAL(RX_LAST)
	<td>DOC_CMD_USAGE(last, #last)
	<td>read last cell of each ATM AAL5 user PDU (packet)
    <tr><td>DOC_CORAL(RX_USER_ALL)
	<td>DOC_CMD_USAGE(user, #user)
	<td>read all bytes of each packet or frame
    <tr><td>DOC_CORAL(RX_ECHO)
	<td>DOC_CMD_USAGE(echo, #echo)
	<td>retransmit received cells on devices which support it
	    (always enabled on POINT cards)
    <tr><td>DOC_CORAL(RX_UNKNOWN)
	<td>
	<td>for traces, read whatever cells are in the
	    trace file; for devices, use default mode
	    (i.e., rx first=48).  Setting this flag clears
	    all other settings.
    </table>
<p>
This function returns 0 for success, -1 for failure.
It only affects sources that are created after it is called.
</p>
<p>
Setting VAR(first) overrides a previously set
CODE(DOC_CORAL(RX_USER_ALL)) flag, and
setting the CODE(DOC_CORAL(RX_USER_ALL)) flag
overrides a previously set VAR(first) value.
Attempting to set both at once has undefined results.
</p>
<p>
The default I/O mode is DOC_CORAL(RX), and first==48.
Currently, an attempt to explicitly use an I/O mode to read a trace that does
not match the I/O mode used to record the trace will generate a warning,
but all the data in the trace will still be read.
In a future release, the read functions may filter trace files according to
the I/O mode (or generate an error if that is not possible).
</p>
<p>
For a
DOC_CMD_USAGE(summary, #sourcenames)
of the iomode options supported by the various interface types,
see the DOC_CMD_USAGE(command usage) document.
</p>


DOC_ENTRY(<:
DOC_DECL(const DOC_TYPEREF(io_mode) *coral_get_iomode, void)
:>,<:
DOC_DECL(get_iomode, )
:>)
<p>
Return the default iomode
as set by CODE(DOC_IDREF(set_iomode)()) or command line options.
DOC_PERL(<:The iomode is returned in the form (flags, first_n).:>)
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_errfile, FILE *file)
DOC_DECL(int coral_set_errfilename, const char *filename)
DOC_DECL(FILE *coral_get_errfile, void)
:>,<:
DOC_DECL(set_errfilename, STR filename)
:>)
<p>
DOC_BOTH(
    CODE(DOC_IDREF(set_errfile)()) and CODE(DOC_IDREF(set_errfilename)()) set,
    CODE(DOC_IDREF(set_errfilename)()) sets)
the destination for future libcoral error and warning messages.
DOC_C(<:VAR(file) is an already opened stdio stream pointer, and:>)
VAR(filename) is the name of a file that will be opened by DOC_name.
Any previously set error file will be closed only if it was set by name other
than "-"DOC_C(<:
(i.e., by CODE(DOC_IDREF(set_errfilename)()),
but not by CODE(DOC_IDREF(set_errfile)())):>).
If DOC_C(VAR(file) or) VAR(filename) is CODE(DOC_NULL),
stderr will be used.
If VAR(filename) is CODE("-"), stdout will be used.
DOC_C(<:CODE(DOC_IDREF(get_errfile)()) returns the current message destination.:>)
The default message destination is stderr.
</p>
<p>
If the name of the error file contains "%", the error file will be
DOC_REF(rotatable, #DOC_ID(rotfile)) and the actual filename will be
generated as described in DOC_IDREF(rf_open).
Unlike normal DOC_REF(rotfiles, #DOC_ID(rotfile)),
a rotating error file is always writable
by DOC_C(<:DOC_IDREF(diag) and :>)DOC_name;
it does not need to be started.
A rotatable error file will rotate automatically at the beginning of each
interval of DOC_IDREF(read_pkt) or DOC_IDREF(read_pkts), unless then
DOC_OPT(NO_AUTOROTATE_ERRFILE) option is set.
In any case, CODE(DOC_IDREF(rotate_errfile)) can be called to rotate
the error file explicitly.
If rotation fails, the error file resets to stderr.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_verbosity, int verbosity)
DOC_DECL(int coral_get_verbosity, void)
:>,<:
DOC_DECL(set_verbosity, NUM verbosity)
DOC_DECL(get_verbosity, )
:>)
<p>
Set or get the verbosity level of DOC_name<::>DOC_C(<: and CODE(DOC_IDREF(diag)()):>).
If verbosity==0, only errors are printed;
if verbosity==1 errors and warnings are printed.
DOC_C(<:Meanings for values greater than 1 may be assigned by the programmer
for use with CODE(DOC_IDREF(diag)()).:>)
The default verbosity is 1.
To completely disable coral messages, set the verbosity to -1.
</p>

DOC_LABEL(DOC_ID(set_max_pkts), DOC_ID(set_max_cells), DOC_ID(set_max_blks),
	  DOC_ID(get_max_pkts), DOC_ID(get_max_cells), DOC_ID(get_max_blks))
DOC_ENTRY(<:
DOC_DECL(int coral_set_max_pkts, uint64_t n)
DOC_DECL(int coral_set_max_cells, uint64_t n)
DOC_DECL(int coral_set_max_blks, uint64_t n)
DOC_DECL(uint64_t coral_get_max_pkts, void)
DOC_DECL(uint64_t coral_get_max_cells, void)
DOC_DECL(uint64_t coral_get_max_blks, void)
:>,<:
DOC_DECL(set_max_pkts, NUM n)
DOC_DECL(set_max_cells, NUM n)
DOC_DECL(set_max_blks, NUM n)
DOC_DECL(get_max_pkts, )
DOC_DECL(get_max_cells, )
DOC_DECL(get_max_blks, )
:>)
<p>
These functions get or set the maximum record count that will be read
by the reading APIs.
When the limit is reached, reading functions will indicate EOF.
If set to zero, there is no limit.  All three counts are zero by default.
</p>
<table border="1">
<tr><td>count		<td>affected APIs
<tr><td>
<tr><td>max_pkts	<td>packet
<tr><td>max_cells	<td>cell
<tr><td>max_blks	<td>DOC_C(block and )cell
</table>
<p></p>

DOC_LABEL(DOC_ID(set_skip_pkts), DOC_ID(get_skip_pkts))
DOC_ENTRY(<:
DOC_DECL(int coral_set_skip_pkts, uint64_t n)
DOC_DECL(uint64_t coral_get_skip_pkts, void)
:>,<:
DOC_DECL(set_skip_pkts, NUM n)
DOC_DECL(get_skip_pkts, )
:>)
<p>
Get or set the number of packets that will be discarded
by the packet reading API.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_set_comment, const char *comment)
DOC_DECL(const char *coral_get_comment, void)
:>,<:
DOC_DECL(set_comment, STR comment)
DOC_DECL(get_comment, )
:>)
<p>
Set or get the default comment that will be written in the file header by the
CODE(DOC_IDREF(write)) functions.  The default comment may
be overridden by
DOC_BOTH(
CODE(DOC_IDREF(write_set_comment)()),
the VAR(comment) parameter of CODE(DOC_IDREF(write_open)())).
</p>

DOC_LABEL(duration)

DOC_ENTRY(<:
DOC_DECL(int coral_set_duration, long duration)
DOC_DECL(long coral_get_duration, void)
:>,<:
DOC_DECL(set_duration, NUM duration)
DOC_DECL(get_duration, )
:>)
<p>
Set or get the duration value.
</p>
<p>
If the duration value is greater than 0, it determines how long libcoral will
read from sources after they are started; after the duration has expired, the
reading function will indicate EOF.  Libcoral uses both real time and
cell timestamps to test duration, so it will work with tracefiles and devices
receiving live traffic.
</p>
<p>
With the default duration of -1, the CODE(DOC_IDREF(config)) functions
will not allow duration to be set.
To have your application not use duration by default, but still let the
user override it, set it to 0
before calling the CODE(DOC_IDREF(config)) functions.
</p>
<p>
Before version 3.3.0, libcoral did not test duration when reading;
the programmer was expected to handle it himself.
Now, the programmer should do nothing other than enable it,
and let libcoral's reading functions handle the duration.
</p>
<p>
Libcoral does not use SIGALRM to implement duration.
</p>

DOC_LABEL(interval)

DOC_ENTRY(<:
DOC_DECL(int coral_set_interval, const struct timeval *interval)
DOC_DECL(int coral_get_interval, struct timeval *interval)
:>,<:
DOC_DECL(set_interval, LIST REF interval)
DOC_DECL(get_interval, )
:>)
<p>
Set or get the interval value.
If the interval has not yet been set, CODE(DOC_IDREF(get_interval)())
DOC_C(<:
returns -1 and fills in *VAR(interval) with { -1, -1 }; otherwise, it
returns 0 and fills in *VAR(interval) with the nonnegative interval value.:>)
DOC_PERL(<:
returns (-1, -1, -1); otherwise, it returns (0, sec, usec),
where VAR(sec) and VAR(usec) are the seconds and microseconds,
respectively of a nonnegative interval value.
:>)
</p>
<p>
The interval value is never automatically used by libcoral; it just provides a
convenient and consistent way to let the user set an interval on the command
line or in a config file.  The programmer may use the interval by passing
the result of CODE(DOC_IDREF(get_interval)()) in as a parameter to
CODE(DOC_IDREF(read_pkt_init)()) or
CODE(DOC_IDREF(read_cell_i)()).
Libcoral uses cell/packet timestamps, not real time, to test for intervals.
Therefore the intervals it
reports will be correct for both tracefiles and devices, although the act
of reporting may be delayed because of internal buffering.
</p>
<p>
With the default interval of -1, the CODE(DOC_IDREF(config)) functions
will not allow interval to be set.
To have your application not use interval by default, but still let the
user override it, set it to 0.0
before calling the CODE(DOC_IDREF(config)) functions.
</p>
<p>
Libcoral does not use SIGALRM to implement interval.
</p>
<p>
See also: DOC_OPT(ALIGNINT).
</p>

DOC_LABEL(dropinterval)

DOC_ENTRY(<:
DOC_DECL(int coral_set_dropinterval, const struct timeval *dropinterval)
DOC_DECL(int coral_get_dropinterval, struct timeval *dropinterval)
:>,<:
DOC_DECL(set_dropinterval, LIST REF dropinterval)
DOC_DECL(get_dropinterval, )
:>)
<p>
Set or get the dropinterval value.
The default dropinterval value is { 0, 0 }.
If the dropinterval has been set to a negative value,
CODE(DOC_IDREF(get_dropinterval)())
DOC_C(<:
returns -1 and fills in *VAR(interval) with { -1, -1 }; otherwise, it
returns 0 and fills in *VAR(interval) with the nonnegative interval value.:>)
DOC_PERL(<:
returns (-1, -1, -1); otherwise, it returns (0, sec, usec),
where VAR(sec) and VAR(usec) are the seconds and microseconds,
respectively of a nonnegative interval value.
:>)
</p>
<p>
A positive value for dropinterval is used as the period with which
CODE(DOC_IDREF(read_pkt)()) will report packet drops on live pcap interfaces
to the DOC_REF(error file, #DOC_ID(set_errfilename)).
</p>
<p>
Note that dropinterval uses setitimer() and SIGALRM.  If that would interfere
with your application, you may prevent the user from setting dropinterval
on the command line by setting it to a negative value
before calling the CODE(DOC_IDREF(config)) functions.
</p>
<p>
The dropinterval is independent of the normal
DOC_REF(interval, #DOC_ID(set_interval)) and DOC_OPT(ALIGNINT).
</p>

DOC_LABEL(mintime)

DOC_ENTRY(<:
DOC_DECL(int coral_set_mintime, const struct timeval *t)
DOC_DECL(int coral_get_mintime, struct timeval *t)
DOC_DECL(int coral_set_maxtime, const struct timeval *t)
DOC_DECL(int coral_get_maxtime, struct timeval *t)
:>,<:
DOC_DECL(set_mintime, LIST REF t)
DOC_DECL(get_mintime, )
DOC_DECL(set_maxtime, LIST REF t)
DOC_DECL(get_maxtime, )
:>)
<p>
Set or get the mintime or maxtime value.
If the desired value has not yet been set, the get functions
DOC_C(<:
return -1 and fill in *VAR(t) with { -1, -1 }; otherwise, they
return 0 and fill in *VAR(t) with the nonnegative interval value.:>)
DOC_PERL(<:
return (-1, -1, -1); otherwise, they return (0, sec, usec),
where VAR(sec) and VAR(usec) are the seconds and microseconds,
respectively of a nonnegative time value.
:>)
</p>
<p>
Libcoral will discard all packets whose timestamp is less than mintime
or greater than maxtime.
Libcoral uses cell/packet timestamps, not real time, to test these time bounds,
so the packets it
discards will be correct for both tracefiles and devices.
</p>
<p>
With the default duration of -1, the CODE(DOC_IDREF(config)) functions
will not allow interval to be set.
To have your application not use time bounds by default, but still let the
user override them, set duration to 0
before calling the CODE(DOC_IDREF(config)) functions.
</p>

DOC_LABEL(gzip)

DOC_ENTRY(<:
DOC_DECL(int coral_set_gzip, const str *mode)
:>,<:
DOC_DECL(set_gzip, STR mode)
:>)
<p>
If mode is CODE(DOC_NULL), CODE(DOC_IDREF(write_open)()) will not gzip files
unless they end in ".gz".
If mode is "", CODE(DOC_IDREF(write_open)()) will gzip files with the
default parameters (compression level 1).
If mode is a non-empty string,
CODE(DOC_IDREF(write_open)()) will append it to the "wb" mode when calling
CODE(gzopen()); see the zlib documentation for details.
</p>

</dl>

DOC_H3(Source Configuration, source)
These functions define and configure sources.  They may only be called
before opening sources.
<dl>


DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Source) *coral_new_source, const char *sourcename)
:>,<:
DOC_DECL(new_source, STR sourcename)
:>)
<p>
Create a new coral DOC_CMD_USAGE(source, #sources)
from VAR(sourcename).
Sources are described in the
DOC_CMD_USAGE(Command usage, #sources) document.
Returns source pointer if successful, or CODE(DOC_NULL) for failure.
This function is useful for creating a source directly from the program
(instead of through command line and config file with the
CODE(DOC_IDREF(config)) functions).
</p>


DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Source) *coral_new_fdsource, int fd,
    const char *sourcename)
:>,<:
DOC_DECL(new_fsource, FILEHANDLE file, STR sourcename = undef)
:>)
<p>
Like DOC_IDREF(new_source), except that it uses the already-open
file DOC_BOTH(descriptor VAR(fd), handle VAR(file))
instead of a filename.
If VAR(sourcename) is not CODE(DOC_NULL), CODE(DOC_IDREF(open)())
will examine it for a DOC_CMD_USAGE(prefix or suffix, #sources)
to determine how to interpret the data read from VAR(DOC_BOTH(fd,file));
otherwise, CODE(DOC_IDREF(open)())
will assume data from VAR(DOC_BOTH(fd,file)) contains a
DOC_CMD_USAGE(CoralReef (crl), #crl) trace.
This function is useful for creating a source directly from a
file DOC_BOTH(descriptor, handle) in the program;
for example, a socket connected to another process that used
CODE(DOC_IDREF(DOC_BOTH(write_fdopen,write_fopen))()).
</p>
<p>
Mixing CoralReef operations with other operations
on DOC_BOTH(descriptor VAR(fd), handle VAR(file)) may have unpredictable
effects.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_source_set_iomode, DOC_TYPEREF(Source) *src,
    unsigned off, unsigned on, int first)
DOC_DECL(int coral_source_set_iomode_all, unsigned off, unsigned on, int first)
:>,<:
DOC_DECL(source_set_iomode, SCALAR src, NUM off, NUM on, NUM first = -1)
DOC_DECL(source_set_iomode_all, NUM off, NUM on, NUM first = -1)
:>)
<p>
These functions modify the I/O mode of the indicated already defined sources.
The VAR(off), VAR(on), and VAR(first) arguments are
identical to those of DOC_IDREF(set_iomode)().
These functions return 0 for success, -1 for failure.
</p>
<p>
To set the default I/O mode of sources that have not yet been defined, use
DOC_IDREF(set_iomode)().
</p>

DOC_ENTRY(<:
DOC_DECL(const DOC_TYPEREF(io_mode) *coral_source_get_iomode,
    const DOC_TYPEREF(Source) *src)
DOC_DECL(const DOC_TYPEREF(io_mode) *coral_iface_get_iomode,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(source_get_iomode, SCALAR src)
DOC_DECL(iface_get_iomode, SCALAR iface)
:>)
<p>
Return the iomode of VAR(src) or VAR(iface), respectively.
Note that for live interfaces, it is the iomode of the interface that
determines how data is read; the iomode of the source is just a default
that an interface may inherit.  For file interfaces, the iomode of the
interface is that of the original device, and the iomode of the
source has little meaning.
DOC_PERL(<:The iomode is returned in the form (flags, first_n).:>)
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_format_iomode,
    char *buffer, const DOC_TYPEREF(io_mode) *iomode)
:>,<:
DOC_DECL(coral_format_iomode, LIST REF iomode)
:>)
<p>
DOC_BOTH(<:
Prints a human-readable representation of VAR(iomode) into VAR(buffer).
VAR(buffer) must be at least CODE(CORAL_FORMAT_IOMODE_LEN) bytes long.
Returns the length of the formatted string.
:>,
<:
Returns a human-readable representation of VAR(iomode).
VAR(iomode) is a reference to a two-element array, such as CODE(<:[$flags, $first_n]:>), where VAR($flags) and VAR($first_n) are returned by DOC_IDREF(source_get_iomode) or DOC_IDREF(iface_get_iomode).
:>
)
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_source_set_firmware, DOC_TYPEREF(Source) *src,
    const char *firmware)
DOC_DECL(int coral_source_set_firmware_all, const char *firmware)
:>,<:
DOC_DECL(source_set_firmware, SCALAR src, STR firmware)
DOC_DECL(source_set_firmware_all, STR firmware)
:>)
<p>
Set the location of the firmware file of source VAR(src),
or of all sources.  The firmware will be loaded when the source is opened.
Returns 0 for success, -1 for failure.
</p>

</dl>

DOC_H3(Opening, opening)
Sources must be DOC_REF(opened, #DOC_ID(open)) and
DOC_REF(started, #DOC_ID(start)) before they can be read.
When they are no longer needed, they may be DOC_REF(stopped, #DOC_ID(stop))
and should be DOC_REF(closed, #DOC_ID(close)).
Note that failing to close a DAG card source may leave it in an unusable state
(CODE(/proc/dag) will report the device is "Busy");
the card must be re-initialized before CoralReef can read from it again.

<dl>


DOC_ENTRY(<:
DOC_DECL(int coral_open, DOC_TYPEREF(Source) *src)
DOC_DECL(int coral_open_all, void)
:>,<:
DOC_DECL(open, SCALAR src)
DOC_DECL(open_all, )
:>)
<p>
Open the indicated coral DOC_REF(sources, #intro) that have been created by
CODE(DOC_IDREF(config_arguments)()), CODE(DOC_IDREF(config_options)()),
CODE(DOC_IDREF(config_command)()), and CODE(DOC_IDREF(new_source)()),
but do not start them.
If successful, these functions return the number of interfaces opened.
If unsuccessful, these functions return -1 and DOC_REF(close, #DOC_ID(close))
the source which failed.
Note that a single tracefile source may contain multiple interfaces.
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_start, DOC_TYPEREF(Source) *src)
DOC_DECL(int coral_start_all, void)
:>,<:
DOC_DECL(start, SCALAR src)
DOC_DECL(start_all, )
:>)
<p>
Start capture on interface(s) of the indicated coral sources which have been
opened with CODE(DOC_IDREF(open)()) or CODE(DOC_IDREF(open_all)()).
Additionally, CODE(DOC_IDREF(start_all)()) resets the clocks of all
open interfaces that allow it, to synchronize them.
A source can not be read until it is started with one of these functions.
(Prior to version 3.3, it was not strictly necessary to start tracefile
sources.)
</p>


DOC_ENTRY(<:
DOC_DECL(int coral_stop_all, void)
DOC_DECL(int coral_stop, DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(stop_all, )
DOC_DECL(stop, SCALAR src)
:>)
<p>
Stop capturing on all interfaces of the indicated device sources.
Returns 0 for success, -1 for failure.
After a source is stopped, it may still contain buffered data, which can be
read until the reading function returns an EOF indication.
These functions are not safe to call asynchronously
(e.g., from a signal handler).
</p>
DOC_C(
<p>
See also:  DOC_IDREF(pkt_done).
</p>
)


DOC_ENTRY(<:
DOC_DECL(int coral_close_all, void)
DOC_DECL(int coral_close, DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(close_all, )
DOC_DECL(close, SCALAR src)
:>)
<p>
Close all interfaces of the indicated sources, after flushing any partially
filled blocks.
Returns 0 for success, -1 for failure.
</p>

</dl>


DOC_H3(Packet Reading, packet)
<p>
The packet reading functions may be used with any CoralReef interface that has
been DOC_REF(started, #DOC_ID(start)).
All time is measured against packet
timestamps, so it works even for trace files that aren't in real time.
If DOC_REF(pcap filtering, #pcap-filtering) is enabled,
packets that do not match the filter are discarded.
If DOC_REF(anonymization, #anon) is enabled,
IP addresses in packets will be anonymized,
and non-IP packets are truncated.
DOC_C(<:See CODE(crl_print_pkt.c) for a good example of using the packet API.:>)
</p>
<p>
Note that the data in packets returned by the packet API is not guaranteed
to have any particular alignment.
DOC_C(<:
The functions CODE(DOC_REF(crl_nptohl(), #crl_nptohl)) and
CODE(DOC_REF(crl_nptohs(), #crl_nptohs)) can be used to convert data to
host byte order and handle the alignment at the same time.
:>)
</p>

DOC_H4(Single packet reading, single-packet)
<dl>

DOC_ENTRY(<:
DOC_DECL(int coral_read_pkt_init, DOC_TYPEREF(Source) *src,
    DOC_TYPEREF(Iface) *iface, struct timeval *interval)
:>,<:
DOC_DECL(read_pkt_init, SCALAR src,
    SCALAR iface, LIST REF interval = undef)
:>)
<p>
Prepare to read packets from an open VAR(src) or VAR(iface) with
CODE(DOC_IDREF(read_pkt)()).
If VAR(iface) is not CODE(DOC_NULL),
packets will be read from VAR(iface);
otherwise, if VAR(src) is not CODE(DOC_NULL),
packets will be read from all interfaces of VAR(src);
otherwise, packets will be read from all interfaces of all open sources.
There is no restriction on reading multiple pcap sources or mixing pcap and
OCx sources, as there was prior to version 3.4.
If VAR(iface) belongs to a source with multiple interfaces, data
from the other interfaces of that source will be discarded.
Packets can be read from only one set of sources at a time;
calling CODE(DOC_IDREF(read_pkt_init)()) invalidates any sources that were
previously initialized for packet reading.
VAR(Interval) is the amount of time CODE(DOC_IDREF(read_pkt)())
will wait between returning statistical information (measured against packet
timestamps).
DOC_PERL(<:
To set the interval, give CODE(DOC_IDREF(read_pkt_init)()) a
reference to a 2-element array representing the seconds
and microseconds of the interval, such as [100, 0], which might
come from CODE(DOC_IDREF(get_interval)()).
<var>Interval</var> defaults to CODE(DOC_NULL), which disables interval handling.
CODE(DOC_IDREF(read_pkt_init)()) returns 0 if successful, or -1 if an
error occurs.
:>)
</p>
<p>
Because CODE(DOC_IDREF(read_pkt)()) must be able to compare timestamps,
CODE(DOC_IDREF(read_pkt_init)())
will automatically enable the
DOC_OPT(NORMALIZE_TIME)
option if necessary.
</p>
<p>
CODE(DOC_IDREF(read_pkt_init)()) returns 0 if successful, or -1 if an
error occurs.
</p>


DOC_ENTRY(<:
DOC_DECL(DOC_IDREF(iface_t) *coral_read_pkt,
    DOC_TYPEREF(Pkt_result) *pkt_result,
    DOC_IDREF(interval_result_t) *interval_result)
:>,<:
DOC_DECL(read_pkt, DOC_TYPEREF(Pkt_result) pkt_result,
    DOC_TYPEREF(Interval_result) interval_result = undef)
:>)
<p>
Read a packet from one of the interfaces which have been
initialized with CODE(DOC_IDREF(read_pkt_init)()).
If a DOC_REF(packet filter, #DOC_ID(add_pcap_filter)) has been set, only
packets that match the filter will be read.
Packets read are sorted by time only if the DOC_OPT(SORT_TIME) option
was set when CODE(DOC_IDREF(read_pkt_init)()) is called
(prior to version 3.6, packets were always sorted by time,
regardless of the setting of the DOC_OPT(SORT_TIME) option).
Even if sorting is disabled, packets will be returned in the correct interval,
and no packets will be returned after the duration has expired.
If the DOC_OPT(PARTIAL_PKT)
option is turned <em>off</em>, only complete packets will be read
(but truncated packets are always counted by the VAR(truncated) field of
DOC_TYPEREF(Pkt_stats)).
</p>
<p>
VAR(pkt_result) and VAR(interval_result) are
DOC_BOTH(
<:pointers to structures (allocated by the programmer):>,
<:references to objects created by the user:>
)
that will be filled in by the call.
For success, CODE(DOC_IDREF(read_pkt)()) returns DOC_C(a pointer to )
the interface which was read,
and the contents of the DOC_BOTH(structures, objects) indicate what happened:
</p>

<dl>
DOC_BOTH(
<:<dt>CODE(if (pkt_result-&gt;packet != NULL) {):>,
<:<dt>CODE(if (defined pkt_result-&gt;packet) {):>
)
    <dd>A packet was read; information about the packet is contained in
    CODE(pkt_result).<br />
    CODE(pkt_result-&gt;packet) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the link layer (LLC/SNAP, ethernet, etc) PDU.
    On ATM interfaces,
    CODE(pkt_result-&gt;header) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the first 4 bytes of the ATM header of the last captured cell
    of the packet (in network byte order);
    CODE(pkt_result-&gt;trailer) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the AAL5 trailer (in network byte order), if available; and
    CODE(pkt_result-&gt;subiface) will contain the ATM vpvc
    (in host byte order) from which the packet was read.
    On IEEE 802.3/Ethernet interfaces carrying IEEE 802.1Q VLAN traffic, 
    CODE(pkt_result-&gt;subiface) will be the VLAN ID.
    On other types of interfaces, CODE(pkt_result-&gt;header)
    and CODE(pkt_result-&gt;trailer) will be CODE(DOC_NULL),
    and CODE(pkt_result-&gt;subiface) will be 0.
DOC_BOTH(
<:<dt>CODE(} else if (interval_result-&gt;stats == NULL) {):>,
<:<dt>CODE(} elsif (not defined interval_result-&gt;stats) {):>
)
    <dd>An interval has begun at time CODE(interval_result-&gt;begin).
    (CODE(interval_result-&gt;end) is not valid.)
<dt>CODE(} else {)
    <dd>The interval begun at time CODE(interval_result-&gt;begin) and
    ending at CODE(interval_result-&gt;end) has ended.
    Statistics for the interval are contained in
    CODE(interval_result-&gt;stats).
    All packets read after this point will have timestamps greater than
    CODE(interval_result-&gt;end), even if 
    the DOC_OPT(SORT_TIME) option is not enabled.
<dt>CODE(})
</dl>
<p>
</p>

<p>
If the VAR(interval) specified in CODE(DOC_IDREF(read_pkt_init)()) was
CODE(DOC_NULL) or 0,
VAR(interval_result) may be DOC_PERL(omitted or )CODE(DOC_NULL),
and CODE(DOC_IDREF(read_pkt)()) will never return with
CODE(pkt_result-&gt;packet == DOC_NULL).
The beginning of an interval is <em>not</em> aligned to a multiple of
the interval size.
When reading from a live interface, internal buffering may cause reporting of
the end of the interval to be delayed, but the data reported will cover exactly
the requested interval.
(In versions 3.2.x, the reported interval included "quiet" (trafficless) time
after the end of the requested time.
In versions 3.1 and earlier, the data reported
included packets past the end of the interval that fell in the same internal
buffer as the end of the interval.)  Interval comparisons are made against
packet timestamps, not a real clock, so the same results will be produced by
reading a live interface or reading a trace taken on that interface in the
same period.
</p>
<p>
The protocol of CODE(pkt_result-&gt;packet) is determined by the interface type.
For ATM interfaces, the protocol is determined by the virtual channel and
DOC_CMD_USAGE(CODE(proto), #proto)
configuration rules DOC_C(as by CODE(DOC_IDREF(proto_rule)())).
Note that if the configuration is incorrect, the packet buffer will
not make sense.
For TSH interfaces, the protocol for a valid packet is always
DOC_PROTO(NETPROTO_IPv4),
and IP options are always zero; the protocol of an invalid packet is
DOC_PROTO(PROTO_UNKNOWN).
Packets read from raw IP sources (i.e., pcap DLT_RAW) will have their
protocol set to DOC_PROTO(NETPROTO_IPv4) or DOC_PROTO(NETPROTO_IPv6)
if they contain at least 1 byte of data; otherwise, they will have
protocol DOC_PROTO(NETPROTO_RAW_IP).
</p>
DOC_C(
<:<p>
If DOC_IDREF(cell_block_hook) points to a
programmer-defined function, it will be called when a new block of ATM cells
is read.
</p>:>)
<p>
To indicate EOF, a DOC_REF(stopped, #DOC_ID(stop)) device, or
expired DOC_REF(duration, #duration),
CODE(DOC_IDREF(read_pkt)()) returns
CODE(DOC_NULL) with CODE(DOC_errno == 0).
For an error, CODE(DOC_IDREF(read_pkt)())
returns CODE(DOC_NULL) with
CODE(DOC_errno) set to indicate the type of error.
(Certain types of errors that were reported as EOF in versions prior 3.5
are now correctly reported as errors.)
</p>
<p>
If DOC_IDREF(get_verbosity)() &gt;= 1, then
at the end of every interval, 
if there were any packet errors
(nonzero fields in CODE(interval_result-&gt;stats))
during the interval,
CODE(DOC_IDREF(read_pkt)())
prints warnings to the DOC_REF(error file, #DOC_ID(set_errfilename)).
If intervals were not used, the warnings are printed only at EOF,
covering the entire duration.
</p>
<p>
Typical packet reading code looks like this:
</p>
<pre>
{
    DOC_BOTH(
    <:DOC_TYPEREF(Iface) *iface;
    DOC_TYPEREF(Pkt_result) pkt_result;
    DOC_TYPEREF(Interval_result) interval_result;
    struct timeval interval = {300,0};
    ...
    DOC_IDREF(read_pkt_init)(DOC_NULL, DOC_NULL, &amp;interval);:>,
    <:$pkt_result = new Coral::Pkt_result;
    $interval_result = new Coral::Interval_result;
    Coral::DOC_IDREF(read_pkt_init)(DOC_NULL, DOC_NULL, $interval);:>)
    while (1) {
	DOC_BOTH(
	<:iface = DOC_IDREF(read_pkt)(&amp;pkt_result, &amp;interval_result);:>,
	<:$iface = Coral::DOC_IDREF(read_pkt)($pkt_result, $interval_result);:>)
	if (!iface) {
	    DOC_COM(error)
	    DOC_BOTH(break, last);
	}
	if (DOC_BOTH(pkt_result.packet, defined $pkt_result->packet)) {
	    DOC_COM(got packet)
	    ...
        } DOC_elseif (DOC_BOTH(!interval_result.stats, not defined $interval_result->stats)) {
	    DOC_COM(beginning of interval)
	    ...
	} else {
	    DOC_COM(end of interval)
	    ...
	}
    }
}
</pre>
</dl>

DOC_C(<:
DOC_H4(Callback loop packet reading, callback-packet)
<dl>

DOC_ENTRY(<:
DOC_DECL(int coral_read_pkts,
		DOC_TYPEREF(Source) *src, DOC_TYPEREF(Iface) *iface,
		DOC_IDREF(pkt_handler) pkthandler, 
		DOC_IDREF(pre_interval_handler) preinthandler, 
		DOC_IDREF(post_interval_handler) postinthandler,
		struct timeval *interval,
		void *mydata)
:>)
<p>
Reads packets from one or more interfaces, and calls a handler function
for each packet read and for the beginning and end of each interval.
VAR(Src), VAR(iface), and VAR(interval)
are interpreted as in CODE(DOC_IDREF(read_pkt_init)()).
CODE(DOC_IDREF(read_pkts)()) repeatedly reads link level packets
(using DOC_IDREF(read_pkt)())
until CODE((DOC_IDREF(pkt_done) != 0))
or EOF is reached on all interfaces.
</p>
<p>
VAR(Pkthandler) is a pointer to a function that will be called for
each packet received.
</p>
<p>
VAR(Preinthandler) and VAR(postinthandler) are pointers to
functions that will be called before and after each interval of
*VAR(interval) seconds in which packets were received.
VAR(Preinthandler) and VAR(postinthandler) are not called if they
are CODE(DOC_NULL), VAR(interval) is CODE(DOC_NULL),
or *VAR(interval) is less than or equal to 0.0.
</p>
<p>
VAR(Mydata) will be passed
as a parameter to the handler functions, but otherwise ignored; the programmer
may use it as needed.
</p>
<p>
VAR(Postinthandler) may set CODE(DOC_IDREF(pkt_done)) to nonzero to
make CODE(DOC_IDREF(read_pkts)()) stop looping and return.
</p>
<p>
CODE(DOC_IDREF(read_pkts)()) returns 0 if it reaches EOF with no errors;
or -1 if there is an error, with errno set to indicate the type of error.
(Certain types of errors that were reported as EOF in versions prior to 3.5
are now correctly reported as errors.)
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(typedef void (*coral_pkt_handler),
    DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *timestamp,
    void *mydata, DOC_TYPEREF(Pkt_buffer) *packet,
    DOC_TYPEREF(Pkt_buffer) *header, DOC_TYPEREF(Pkt_buffer) *trailer)
:>)
<p>
CODE(coral_pkt_handler) is the type of the function called each time
CODE(DOC_IDREF(read_pkts)()) reads a packet.
Parameters:
</p>
    <dl>
    <dt>VAR(iface)
        <dd>a pointer to the interface from which the packet was read.
    <dt>VAR(timestamp)
        <dd>the time at which the packet was read (usable with the
	DOC_IDREF(read_clock) functions).
    <dt>VAR(mydata)
        <dd>the VAR(mydata) parameter that was passed to
        CODE(DOC_IDREF(read_pkts)()).
    <dt>VAR(packet)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing a link level packet, not including a trailer.
    <dt>VAR(header)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing the header used at a next lower layer, or CODE(DOC_NULL).
	Currently, this is only used for the ATM header of the last received
	cell in the packet; the ATM header will be in network byte order
	(in version 3.1, this was in host byte order).
    <dt>VAR(trailer)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing the trailer used at a next lower layer,
	if the lower layer uses trailers and the packet was not truncated;
	otherwise, CODE(DOC_NULL).
	Currently, this is only used for the ATM AAL5 trailer.
    </dl>
<p>
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(<:typedef void (*coral_pre_interval_handler):>,
	DOC_TYPEREF(Iface) *iface, const struct timeval *begin, void *mydata)
DOC_DECL(<:typedef void (*coral_post_interval_handler):>,
	DOC_TYPEREF(Iface) *iface, const struct timeval *begin,
	const struct timeval *end, void *mydata,
	const DOC_TYPEREF(Pkt_stats) *stats)
:>)
<p>
CODE(coral_pre_interval_handler) and CODE(coral_post_interval_handler)
are the types of the functions called before and after (respectively) each
interval of CODE(DOC_IDREF(read_pkts)()).
Parameters:
</p>
    <dl>
    <dt>VAR(iface)
        <dd>the interface being read.
    <dt>VAR(begin)
        <dd>the beginning of the interval.
    <dt>VAR(mydata)
        <dd>the VAR(mydata) parameter that was passed to
        CODE(DOC_IDREF(read_pkts)())
    <dt>VAR(stats)
        <dd>a pointer to a structure containing statistics about the interval,
	summed across all interfaces.
	(To get statistics for an individual interface, use
	DOC_IDREF(get_iface_stats)().)
    </dl>
<p>
</p>
</dl>
:>)

DOC_H4(Other packet reading features, other-packet)
<dl>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(const DOC_TYPEREF(Pkt_stats) *coral_get_iface_stats,
    DOC_TYPEREF(Iface) *iface)
:>)
<p>
Returns a DOC_BOTH(pointer, reference) to the 
DOC_TYPEREF(Pkt_stats) structure for
VAR(iface) for the most recent interval.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(extern volatile int coral_pkt_done;)
:>)
<p>
This can be set to a non-zero value at any time
(e.g., in postblkhandler or in a signal handler)
to force either packet reading function to act like it has detected EOF
the next time it is called, on both device and trace file sources.
</p>
<p>
See also: CODE(DOC_IDREF(stop_all)()).
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(extern int (*coral_pkt_atm_hook),
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Pkt_buffer) *packet,
    const DOC_TYPEREF(Atm_cell) *cell)
:>)
<p>
If CODE(coral_pkt_atm_hook) is not CODE(DOC_NULL), the function
to which it points is called each time the first cell of an AAL5 PDU is seen by
CODE(DOC_IDREF(read_pkt)()) or
CODE(DOC_IDREF(read_pkts)())
on an ATM interface.
If this function returns 0, the packet reader function will skip
the packet to which the cell belongs;
if it returns nonzero, or the function pointer is CODE(DOC_NULL),
the packet reader function will process the packet normally.
The CODE(coral_pkt_atm_hook) test is done before any reassembly is
performed, so it is more efficient to discard packets in
CODE(coral_pkt_atm_hook) than after
CODE(DOC_IDREF(read_pkt)()) returns or in the
CODE(coral_pkt_handler) of
CODE(DOC_IDREF(read_pkts)()).
The parameters are:
</p>
<dl>
    <dt>VAR(iface)
	<dd>pointer to the interface from which the cell was read
    <dt>VAR(packet)
	<dd>pointer to a packet structure containing as much data about the
	data link level packet as was available in the first cell.
	This is provided for convenient use with functions that take a
	CODE(DOC_TYPEREF(Pkt_buffer))
	parameter (e.g.,
	CODE(DOC_IDREF(get_payload)())).
    <dt>VAR(cell)
	<dd>pointer to the first cell (in network byte order).
</dl>
<p>
The default value of CODE(coral_pkt_atm_hook) is CODE(DOC_NULL).
</p>
<p>
See also: DOC_IDREF(add_pcap_filter)() and
DOC_IDREF(pcap_setfilter)().
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_get_payload, const DOC_TYPEREF(Pkt_buffer) *src,
    DOC_TYPEREF(Pkt_buffer) *dst)
:>,<:
DOC_DECL(get_payload, DOC_TYPEREF(Pkt_buffer) src,
    DOC_TYPEREF(Pkt_buffer) dst)

:>)
<p>
VAR(src) is a DOC_BOTH(pointer, reference) to a
DOC_TYPEREF(Pkt_buffer)
containing a datagram or packet
(e.g., VAR(packet_result-&gt;packet) from DOC_IDREF(read_pkt)())
with CODE(VAR(src)-&gt;caplen &gt; 0).
DOC_PERL(<:
VAR(Dst) is also a reference to a DOC_TYPEREF(Pkt_buffer),
but is created by the user, e.g.:
"CODE($argument = new DOC_TYPEREF(Pkt_buffer);)".
:>)
CODE(DOC_IDREF(get_payload)()) skips past the lower level (outer) protocol
encapsulation in VAR(src) and fills in VAR(dst) with information
about the payload of VAR(src)
(see DOC_TYPEREF(Pkt_buffer)).
If CODE(DOC_IDREF(get_payload)()) understands the VAR(src) protocol
but does not recognize the protocol of the payload,
CODE(VAR(dst)-&gt;protocol) will contain
DOC_PROTO(PROTO_UNKNOWN) or some other undefined value.
</p>
<p>
CODE(DOC_IDREF(get_payload)()) returns 0 if it successfully parsed
the VAR(src) protocol information, or one of the following negative
error codes:
</p>
<dl compact="compact">
<dt>DOC_CORAL(ENOPROTO)	<dd>libcoral can not parse the protocol indicated by VAR(src)-&gt;protocol
<dt>DOC_CORAL(ELENGTH)	<dd>protocol information was truncated
<dt>DOC_CORAL(ESYNTAX)	<dd>packet data are inconsistent with protocol
<dt>DOC_CORAL(ERROR)	<dd>other error
</dl>
<p>
A return value of DOC_CORAL(ELENGTH) indicates that some desired part of the
packet was truncated, but VAR(dst) will still contain as much information
as was available.
For example, if VAR(src) contained an IPv4 packet truncated between
the length field and the protocol field, then
CODE(VAR(dst)-&gt;buf) will point to the beginning of the next layer,
and CODE(VAR(dst)-&gt;totlen) will be the correct length of the next layer,
but CODE(VAR(dst)-&gt;protocol) will be DOC_PROTO(PROTO_UNKNOWN).
For all other error return values, the contents of VAR(dst) are undefined.
</p>
<p>
The recognized protocols are listed in the
DOC_CMD_USAGE(Protocols, #protocols) section of the
DOC_CMD_USAGE(Command Usage) document.  
Protocol identifiers are formed by concatenating
DOC_BOTH(
<:"CODE(CORAL_)", the prefix, and the name;:>,
<:the prefix and the name, in the Coral namespace;:>
)
e.g., DOC_PROTO(DLT_ETHER).
</p>
<p>
By default, the IPv6 extension headers
HOPOPTS, ROUTING, FRAGMENT, and DSTOPTS are skipped;
but if the DOC_OPT(IP_EXTHDR) option is on, 
they are treated as encapsulated protocols.
The extension headers AH and ESP are never skipped.
So, for example, say you have an Ethernet frame containing an IPv6 packet
with a Routing header, Fragment header, and UDP datagram.
If you call CODE(DOC_IDREF(get_payload)()) with that packet as VAR(src),
and then repeatedly with the VAR(dst) of the previous call as the VAR(src)
of the next,
with DOC_OPT(IP_EXTHDR) off,
the value of CODE(VAR(dst)-&gt;protocol) 
after each successive call would be
DOC_PROTO(NETPROTO_IPv6),
DOC_PROTO(IPPROTO_UDP), and
DOC_PROTO(PROTO_UNKNOWN),
respectively.
But the same sequence with DOC_OPT(IP_EXTHDR) on
would result in
DOC_PROTO(NETPROTO_IPv6),
DOC_PROTO(IPPROTO_ROUTING),
DOC_PROTO(IPPROTO_FRAGMENT),
DOC_PROTO(IPPROTO_UDP), and
DOC_PROTO(PROTO_UNKNOWN).
(In versions 3.5.0 and 3.5.1, this function behaved as if DOC_OPT(IP_EXTHDR)
were always on.)
</p>
<p>
Note:  DOC_CMD_USAGE(TSH files, #sourcenames)
contain IPv4 packet headers only, and when CoralReef reads an IPv4
packet from a DOC_CMD_USAGE(TSH file, #sourcenames)
it fills the missing IP options (if any) with zeros to create
a syntactically valid substring of an IP packet.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_fmt_get_payload, const DOC_TYPEREF(Pkt_buffer) *src,
    DOC_TYPEREF(Pkt_buffer) *dst, char *buf, int len)
:>,<:
DOC_DECL(fmt_get_payload, DOC_TYPEREF(Pkt_buffer) src,
    DOC_TYPEREF(Pkt_buffer) dst, STR REF buf)

:>)
<p>
CODE(DOC_IDREF(fmt_get_payload)()) is like
CODE(DOC_IDREF(get_payload)()), except that it also writes
DOC_C(<:up to VAR(len) characters (including a terminating null character) of:>)
human-readable information about the lower level protocol into VAR(buf).
Returns a nonnegative number if successful,
or -1 for any of the following errors:
CODE(vsnprintf()) is not available on your system
and VAR(buf) is not CODE(DOC_NULL);
or any of the errors listed in the documentation for
DOC_IDREF(get_payload)().
A return value of DOC_CORAL(ELENGTH) indicates that some desired part of the
packet was truncated, but VAR(dst) and VAR(buf) will still contain as much
information as was available.
For all other error return values, the contents of VAR(dst) and VAR(buf)
are undefined.
</p>
<p>
The information written into buf attempts to cover all relevant information
about the protocol.  Irrelevant information is omitted for brevity (for
example: for TCP, the urgent pointer and acknowledgment number are printed
only if the corresponding flags are set;
for IPv4, type-of-service is printed only if it is nonzero,
and the fragment offset is printed only if the packet is a fragment).
The IP checksum will be printed and verified only if the
DOC_OPT(IP_CKSUM)
option is set.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_get_payload_by_proto,
    const DOC_TYPEREF(Pkt_buffer) *src, DOC_TYPEREF(Pkt_buffer) *dst,
    DOC_TYPEREF(Protocol) proto)
DOC_DECL(int coral_get_payload_by_layer,
    const DOC_TYPEREF(Pkt_buffer) *src, DOC_TYPEREF(Pkt_buffer) *dst,
    int layer)
:>,<:
DOC_DECL(get_payload_by_proto,
    DOC_TYPEREF(Pkt_buffer) src, DOC_TYPEREF(Pkt_buffer) dst,
    NUM proto)
DOC_DECL(get_payload_by_layer,
    DOC_TYPEREF(Pkt_buffer) src, DOC_TYPEREF(Pkt_buffer) dst,
    NUM layer)
:>)
<p>
These functions search for the outermost packet in VAR(src) whose
protocol is VAR(proto) or protocol layer is VAR(layer), and
copy that packet's information to VAR(dst).
The copied packet will be VAR(src) itself if its protocol matches the
criterion; otherwise these functions repeatedly call
DOC_IDREF(get_payload)()
to find encapsulated packets.
These functions return 0 if successful, or -1 if
the VAR(proto) or VAR(layer) is not found,
or for any of the errors listed in the documentation for
DOC_IDREF(get_payload)().
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_pkt_truncate,
    const DOC_TYPEREF(Pkt_buffer) *pkt,
    int layer, int unknown, int payload)
:>,<:
DOC_DECL(pkt_truncate,
    DOC_TYPEREF(Pkt_buffer) pkt,
    NUM layer, NUM unknown, NUM payload)
:>)
<p>
Effectively truncates packet by protocol:
keeps the headers of the first VAR(layer) layers plus VAR(payload) bytes
of layer VAR(layer) payload.
It does this by reseting VAR(pkt)->caplen to the lowest of:
<ul>
    <li>its original value;
    <li>if VAR(layer) > 0, the length of the packet up to the end of the
	last header whose layer is VAR(layer), plus VAR(payload);
    <li>if VAR(unknown) is nonzero, the length of the packet up to the
	last header whose protocol is not DOC_PROTO(PROTO_UNKNOWN)
</ul>
</p>
<p>
Returns the same values as DOC_IDREF(get_payload)().
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(const char *coral_get_net_pkt,
    const DOC_TYPEREF(Pkt_buffer) *buffer, int *protocol)
:>)
<p>
Obsolete.  See DOC_IDREF(get_payload)()
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_field_fits, p, FIELDNAME, caplen)
:>)
<p>
Returns nonzero iff <var>p</var>-&gt;<var>FIELDNAME</var> fits within the first
<var>caplen</var> bytes of the structure pointed to by <var>p</var>.
This is useful when you have read a packet that may be truncated and want
to know if a specific header field is valid.
The type of <var>p</var> must be a pointer to a structure that has
<var>FIELDNAME</var> as a member, and <var>FIELDNAME</var> must not
be a bitfield (e.g., ip_hl of struct ip).
</p>
<p>
In the following example, <var>netpkt</var> is a
DOC_TYPEREF(Pkt_buffer) that has already been filled in 
by one of the DOC_IDREF(get_payload) functions.
</p>
<pre>
    if (netpkt.protocol == CORAL_NETPROTO_IP) {
	struct ip *ip = netpkt.buf;
	if (<b>!DOC_IDREF(field_fits)</b>(ip, ip_p, netpkt.caplen)) {
	    DOC_IDREF(printf)("packet too short\n");
	} else {
	    switch (ip->ip_p) {
	    case IPPROTO_TCP:
		...
	    case IPPROTO_UDP:
		...
	    }
	}
    }
</pre>
:>)

</dl>

DOC_H4(Pcap packet filtering, pcap-filtering)
<p>
If libcoral was compiled with libpcap, these functions can be used to set
pcap filter expressions.
Pcap filters can be used with any type of interface, not just BPF devices.
The filter will be executed when it is most efficient:  
in the kernel if the interface is a BPF device,
or before AAL5 reassembly (if possible) if the interface is an ATM
Coral device or file.
The DOC_REF(packet reading functions, #packet) will return only
packets which match the filter.
</p>

<dl>

DOC_ENTRY(<:
DOC_DECL(int coral_add_pcap_filter, const char *expr)
DOC_DECL(int coral_add_pcap_prefilter, const char *expr)
DOC_DECL(int coral_add_pcap_ipfilter, const char *expr)
:>,<:
DOC_DECL(add_pcap_filter, STR expr)
DOC_DECL(add_pcap_prefilter, STR expr)
DOC_DECL(add_pcap_ipfilter, STR expr)
:>)
<p>
If VAR(expr) is not CODE(DOC_NULL), CODE(DOC_IDREF(add_pcap_filter)())
sets VAR(expr) as a global pcap filter expression.
If a filter expression was already set (either by this function or by
DOC_IDREF(config) DOC_CMD_USAGE("filter", #filter) commands),
the old and new expressions are joined as
"CODE((VAR(old_expr)) and (VAR(expr)))".
The expression will be compiled and set on every source that is subsequently
opened; it has no effect on sources that are already open.
</p>
<p>
If VAR(expr) is CODE(DOC_NULL),
CODE(DOC_IDREF(add_pcap_filter)()) clears
any previously set global pcap filter expression.
</p>
<p>
These functions will not work until CODE(DOC_IDREF(set_api)(DOC_CORAL(API_PKT)))
is called.
This function returns 0 if successful,
or -1 with DOC_errno set if there is an error.
</p>
<p>
CODE(DOC_ID(add_pcap_prefilter())) is similar to
CODE(DOC_ID(add_pcap_filter())),
except it sets a "prefilter", which is used only on ATM interfaces,
on the first ATM cell, <em>before</em> AAL5 reassembly.  A prefilter
can be used to avoid unnecessary reassembly, but only if the first ATM
cell contains enough information to apply the filter.  It is up to the
user to make sure the prefilter does not need information that does
not fit in the first cell.
</p>
<p>
CODE(DOC_ID(add_pcap_ipfilter())) is similar to
CODE(DOC_ID(add_pcap_filter())),
except that for each packet CoralReef first skips past layer 2 to find an
IP packet.  If no IP packet is found, the packet is discarded; otherwise, the
filter is tested starting at the IP header.
This is useful when packets contain IP encapsulated in some layer 2
protocol that pcap filters can not parse, but CoralReef can,
such as MPLS.
</p>
<p>
See also the section on DOC_CMD_USAGE(-Cfilter, #filter)
in the DOC_CMD_USAGE(command usage) document.
</p>

DOC_ENTRY(<:
DOC_DECL(const char *coral_get_pcap_filter, void)
DOC_DECL(const char *coral_get_pcap_prefilter, void)
DOC_DECL(const char *coral_get_pcap_ipfilter, void)
:>,<:
DOC_DECL(get_pcap_filter, )
DOC_DECL(get_pcap_prefilter, )
DOC_DECL(get_pcap_ipfilter, )
:>)
<p>
Returns the text of the global pcap filter expression
previously set by
DOC_IDREF(add_pcap_filter)() or DOC_IDREF(add_pcap_prefilter)()
and/or by DOC_IDREF(config)
DOC_CMD_USAGE("filter", #filter) or DOC_CMD_USAGE("prefilter", #prefilter)
commands.
Returns CODE(DOC_NULL) if no filter expression has been set.
</p>

DOC_C(<:
DOC_ENTRY(<:
#include &lt;pcap.h&gt;<br />
DOC_DECL(int coral_pcap_compile, DOC_TYPEREF(Iface) *iface,
    struct bpf_program *fp, char *str, int optimize, uint32_t netmask)
DOC_DECL(int coral_pcap_setfilter, DOC_TYPEREF(Iface) *iface,
    struct bpf_program *fp)
DOC_DECL(int coral_pcap_setprefilter, DOC_TYPEREF(Iface) *iface,
    struct bpf_program *fp)
:>)
<p>
If you need finer control over pcap filtering than
DOC_IDREF(add_pcap_filter)() and
DOC_IDREF(add_pcap_prefilter)() provide,
you can use these functions.  These allow you to recompile and reset
filters at any time (even on interfaces that are already open), and
to assign different filters to different interfaces.
</p>
<p>
These functions are the same as CODE(pcap_compile()) and
CODE(pcap_setfilter()), respectively, except that they apply to a
CODE(DOC_TYPEREF(Iface)) instead of a
CODE(pcap_t).  They are used to compile a tcpdump expression to a
BPF program and install
it onto a Coral interface.  Note that CODE(*VAR(fp)) must remain
in valid memory until VAR(iface) is closed or a new BPF program is
installed on VAR(iface).
</p>
<p>
To avoid confusion when using these functions, you should set the
DOC_OPT(NO_FILTER) option
before calling the DOC_IDREF(config) functions
to prevent the user from specifying a useless DOC_CMD_USAGE("filter", #filter) command.
Alternatively, you could allow the user to use DOC_CMD_USAGE("filter", #filter) commands,
use DOC_IDREF(get_pcap_filter)()
to get it so you can combine it with yours, and 
CODE(DOC_IDREF(add_pcap_filter)(NULL))
to clear the global expression so it won't be applied by
DOC_IDREF(open)().
</p>
<p>
See the DOC_REF(pcap and tcpdump documentation, http://www.tcpdump.org/)
for more information.
</p>
:>)

</dl>

DOC_C(<:
DOC_H4(IP address anonymization, anon)
CoralReef can anonymize IPv4 and IPv6 address by zeroing out bits,
or by using the
DOC_REF(Crypto-PAn, http://www.cc.gatech.edu/computing/Telecomm/projects/cryptopan/)
algorithm,
which preserves prefix relationships.
Anonymization can be enabled on the DOC_CMD_USAGE(command line, #anonymize)
for any application that uses the DOC_REF(packet API, #packet),
or invoked explicitly via the libcoral API described below.

<dl>

dnl DOC_ENTRY(<:
dnl DOC_DECL(coral_PAnonymizer_t *coral_new_PAnonymizer, uint8_t *key)
dnl :>)
dnl <p>
dnl Creates a coral_PAnonymizer_t object for use in future anonymizer calls,
dnl and returns a pointer to it.
dnl VAR(Key) must point to a 256 bit value, which will be used to initialize
dnl the new object.
dnl </p>

dnl DOC_ENTRY(<:
dnl DOC_DECL(void coral_delete_PAnonymizer, coral_PAnonymizer_t *pan)
dnl :>)
dnl <p>
dnl Destroy the coral_PAnonymizer_t object pointed to by VAR(pan).
dnl </p>

dnl DOC_ENTRY(<:
dnl DOC_DECL(coral_PAnonymizer_t *coral_get_PAnonymizer, )
dnl :>)
dnl <p>
dnl Return a pointer to the global coral_PAnonymizer_t object created by the
dnl DOC_CMD_USAGE("anonymize" configuration command, #anonymize)
dnl or DOC_IDREF(set_PAnonymizer).
dnl </p>

DOC_ENTRY(<:
DOC_DECL(coral_anon_t *coral_get_anonymizer, )
:>)
<p>
Return a pointer to a copy of the global coral_anon_t object created by the
DOC_CMD_USAGE("anonymize" configuration command, #anonymize),
or NULL if DOC_CMD_USAGE("anonymize", #anonymize) was not used.
</p>

dnl DOC_ENTRY(<:
dnl DOC_DECL(int coral_set_PAnonymizer, coral_PAnonymizer_t *pan)
dnl :>)
dnl <p>
dnl Set a global coral_PAnonymizer_t object to be used by the
dnl DOC_REF(packet API, #packet).  If VAR(pan) is DOC_NULL,
dnl anonymization in the DOC_REF(packet API, #packet) will be disabled.
dnl Anonymization is applied after DOC_REF(pcap filtering, #pcap-filtering).
dnl </p>
dnl <p>
dnl In applications that do a lot of aggregation and need to output anonymized
dnl results, it can be more efficient to anonymize after aggregation.
dnl To do this, use DOC_IDREF(get_PAnonymizer)() to get the coral_PAnonymizer_t
dnl that was configured on the command line,
dnl use DOC_IDREF(set_PAnonymizer)(DOC_NULL) to disable automatic anonymization,
dnl and call DOC_IDREF(PAnonymize)() or DOC_IDREF(pkt_PAnonymize)()
dnl on each address or packet in the aggregated results before outputting them.
dnl </p>

DOC_ENTRY(<:
DOC_DECL(int coral_set_anonymizer, coral_anon_t *anon)
:>)
<p>
Set a global coral_anon_t object to be used by the
DOC_REF(packet API, #packet).  If VAR(anon) is DOC_NULL,
anonymization in the DOC_REF(packet API, #packet) will be disabled.
Anonymization is applied after DOC_REF(pcap filtering, #pcap-filtering).
</p>
<p>
In applications that do a lot of aggregation and need to output anonymized
results, it can be more efficient to anonymize after aggregation.
To do this, use DOC_IDREF(get_anonymizer)() to get the coral_anon_t
that was configured on the command line,
use DOC_IDREF(set_anonymizer)(DOC_NULL) to disable automatic anonymization,
and call DOC_IDREF(anonymize)() or DOC_IDREF(pkt_anonymize)()
on each address or packet in the aggregated results before outputting them.
</p>

DOC_ENTRY(<:
DOC_DECL(void coral_anonymize_ip4, coral_anon_t *anon, void *newaddr, const void *oldaddr)
DOC_DECL(void coral_anonymize_ip6, coral_anon_t *anon, void *newaddr, const void *oldaddr)
:>)
<p>
Writes an anonymized copy of IPv4 or IPv6 address VAR(oldaddr) into VAR(newaddr).
All addresses are in network byte order.
VAR(anon) must be a pointer to a coral_anon_t object returned by
dnl DOC_IDREF(new_PAnonymizer)() or
DOC_IDREF(get_anonymizer)().
</p>
<p>
Bug: these functions do not know if <var>addr</var> is a source or a
destination address, so they anonymize unconditionally,
ignoring the CODE(src) and CODE(dst)
parameters of the DOC_CMD_USAGE("anonymize" configuration command, #anonymize).
</p>
<p>
Example:
</p>
<pre>
    struct in_addr oldaddr, newaddr;
    coral_anon_t *anon = DOC_IDREF(get_anonymizer)();
    ...
    DOC_IDREF(anonymize_ip4)(anon, &newaddr, &oldaddr);
</pre>

DOC_ENTRY(<:
DOC_DECL(uint32_t coral_anonymize, coral_anon_t *anon, uint32_t addr)
:>)
<p>
Returns an anonymized copy of IPv4 address VAR(addr).
All addresses are in host byte order.
See also DOC_IDREF(anonymize_ip4).

DOC_ENTRY(<:
DOC_DECL(int coral_pkt_anonymize, DOC_TYPEREF(Pkt_buffer) *pkt)
:>)
<p>
Anonymizes source and destination addresses within IPv4 and IPv6 headers of
the packet pointed to by VAR(pkt),
using the global coral_anon_t set by
dnl DOC_IDREF(set_PAnonymizer)() or
the DOC_CMD_USAGE("anonymize" configuration command, #anonymize).
If the packet contains an IP packet which directly or indirectly
encapsulates other IP packets using any protocol that libcoral understands
(e.g., IPIP, or the original IP packet inside an ICMP error message),
addresses in the encapsulated IP headers are also anonymized.
If an address is truncated due to insufficient CODE(VAR(pkt)-&gt;caplen),
the partial address is still anonymized.
IP, TCP, and UDP checksums are incrementally recalculated to reflect the
changed addresses (this is new in version 3.7.4).
<p>
By default, other Layer 3 non-IP headers are truncated at 0 bytes.
Truncation is new in version 3.8.0.
Truncation is prevented if the "notrunc"
DOC_CMD_USAGE(anonymization, #anonymize) parameter was set.
<p>
This function does not anonymize non-IP addresses (e.g., MAC addresses),
nor IP addresses in non-IP headers (e.g., ARP).
<p>
This function always returns 1.
</p>

</dl>
:>)

DOC_C(<:
DOC_H4(Packet reading example, packet-ex)
<pre>
static int count_and_print_pkt(DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, void *mydata,
    DOC_TYPEREF(Pkt_buffer) *buffer, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
{
    long *countp = mydata;

    ++(*countp);
    if (buffer-&gt;caplen == buffer-&gt;totlen)  /* complete capture? */
        printf("bytes: %d\n", buffer-&gt;caplen);
    else
        printf("bytes: %d (of %d)\n", buffer-&gt;caplen, buffer-&gt;totlen);
    DOC_IDREF(fprint_pkt)(stdout, iface, timestamp, 7, buffer, header, trailer);
}

int main()
{
    long count;
    ...
    count = 0;
    DOC_IDREF(read_pkts)(src, NULL, count_and_print_pkt, NULL, NULL, 0, &amp;count);
    printf("received %ld packets.\n", count);
    ...
}
</pre>
:>)


DOC_H3(DOC_BOTH(Cell/Block, Cell) Reading, cell)
DOC_H4(General Description, cell-general)
<p>
The DOC_C(block and )cell reading functions may be used only with ATM interfaces
that have been DOC_REF(started, #DOC_ID(start)).
DOC_C(<:The cell functions are more general than the block functions.:>)
For working with layers 3 and above,
the DOC_REF(packet reading functions, #packet) are usually better.
</p>
<p>
After any of these reading functions are successful,
DOC_BOTH(<:
*VAR(cellp) will point to a single DOC_REF(cell, #DOC_TYPE(atm_cell))
(for the cell functions)
or array of DOC_REF(cells, #DOC_TYPE(atm_cell))
(for the block functions);
and if VAR(binfop) is not CODE(DOC_NULL),
*VAR(binfop) will point to a
DOC_REF(block info structure, #DOC_TYPE(blk_info))
describing the block to which the cell or cells belong.
All structures will be in network byte order.  (In version 3.0, cells
read from FATM devices had ATM headers in little endian order.)
:>, <:
VAR(binfop) will be a reference to a byte string representing the block info,
and VAR(cellp) will be a reference to a DOC_TYPEREF(Cell) object.
VAR(binfop) can be parsed by the DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
:>)
VAR(binfop) may be passed a value of CODE(DOC_NULL) if the block info will not be
needed.
</p>
<p>
If VAR(timeout) is CODE(DOC_NULL) or omitted,
these functions will wait until data are available or an interrupt occurs.
But if VAR(timeout) is not CODE(DOC_NULL),
these functions will also return after
the amount of time specified in VAR(timeout) even if there are no data.
DOC_PERL(<:
To set the timeout, input a reference to a
2-element array representing the seconds and microseconds
of the timeout, such as [100, 0].
:>)
</p>
DOC_C(<:
<p>
If DOC_IDREF(cell_block_hook) is not CODE(DOC_NULL),
the function to which it points will be called when a new block of ATM cells is
read by any of the cell reading functions.
</p>:>)
<p>
The DOC_CMD_USAGE(CODE(deny), #deny) protocol rules
are applied by the cell reading functions
to filter the cells and determine their protocol.
DOC_C(<:
They are not applied by the block reading functions.
In either case, no protocol information is given;
use DOC_IDREF(proto_rule) to get that.
:>)
Note:  prior to version 3.4.2, the cell reading functions did not apply
the the configuration DOC_CMD_USAGE(CODE(deny), #deny) rules.
</p>
<p>
Calls to the different CoralReef reading functions
may not be interleaved on a given set of sources.
</p>
<p>
A call to any CoralReef reading function on a given set
of sources invalidates all data in buffers set by previous calls to
any reading functions on the same set of sources.
</p>

DOC_H4(Return values, cell-return)
<ul>
<li>CODE(DOC_NULL) with CODE(DOC_errno==0) for EOF,
DOC_REF(stopped, #DOC_ID(stop)) device, or
expired DOC_REF(duration, #duration).
(If end-of-file is encountered someplace other than a block boundary, it
is considered an error.)</li>
<li>CODE(DOC_NULL) with CODE(DOC_errno==EAGAIN) if VAR(timeout) is exceeded</li>
<li>CODE(DOC_NULL) with CODE(DOC_errno==EBADF) if sources are not ATM.</li>
<li>CODE(DOC_NULL) with other DOC_errno value for other errors</li>
<li>non-CODE(DOC_NULL) interface DOC_BOTH(pointer, reference) for success</li>
</ul>
(Certain types of errors that were reported as EOF in versions prior 3.5
are now correctly reported as errors.)

DOC_H4(Reading Functions, cell-read)
<dl>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_cell, DOC_TYPEREF(Source) *src,
    DOC_TYPEREF(Blk_info) **binfop, DOC_TYPEREF(atm_cell) **cellp,
    struct timeval *timeout)
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_cell_all,
    DOC_TYPEREF(Blk_info) **binfop, DOC_TYPEREF(atm_cell) **cellp,
    struct timeval *timeout)
:>,<:
DOC_DECL(read_cell, SCALAR src,
    STR REF binfop, DOC_TYPEREF(Cell) cellp, LIST REF timeout = undef)
DOC_DECL(read_cell_all,
    STR REF binfop, DOC_TYPEREF(Cell) cellp, LIST REF timeout = undef)

:>)
<p>
CODE(DOC_ID(read_cell)()) reads a single cell from the indicated source;
CODE(DOC_ID(read_cell_all)()) reads from all open sources.
If the DOC_OPT(SORT_TIME) option is off,
CODE(DOC_IDREF(read_cell_all)()) reads cells in the most
efficient order (i.e., block order);
but if the DOC_OPT(SORT_TIME)
option is on, it will read them
in time-sorted order (interleaving cells from blocks of different interfaces).
If the DOC_OPT(SORT_TIME) is set,
VAR(timeout) is ignored (it is always treated as CODE(DOC_NULL)).
</p>
<p>
See the section introduction above for
DOC_REF(more details, #cell-general) and
DOC_REF(return values, #cell-return).
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_cell_i,
    DOC_TYPEREF(Source) *src, DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, DOC_TYPEREF(Interval_result) *int_result,
    struct timeval *interval)
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_cell_all_i,
    DOC_TYPEREF(Blk_info) **binfop, DOC_TYPEREF(atm_cell) **cellp,
    DOC_TYPEREF(Interval_result) *int_result, struct timeval *interval)
:>,<:
DOC_DECL(read_cell_i, SCALAR src, STR REF binfop,
    DOC_TYPEREF(Cell) cellp, DOC_TYPEREF(Interval_result) int_result,
    LIST REF interval = undef)
DOC_DECL(read_cell_all_i, STR REF binfop,
    DOC_TYPEREF(Cell) cellp, DOC_TYPEREF(Interval_result) int_result,
    LIST REF interval = undef)

:>)
<p>
These functions are like
CODE(DOC_IDREF(read_cell)()) and CODE(DOC_IDREF(read_cell_all)()),
except that there is no VAR(timeout) and they support intervals.
</p>
<p>
If the value of VAR(interval) is greater than 0.0, then
time sorting is automatically enabled regardless of the setting of the
DOC_OPT(SORT_TIME) option, and
whenever *VAR(interval)
seconds have passed or EOF is reached,
the functions will return non-CODE(DOC_NULL) with
DOC_BOTH(CODE(*VAR(cellp) == NULL), CODE(VAR(cellp) == undef))
to indicate that an interval has ended,
and the CODE(start) and CODE(end) fields of VAR(int_result)
will be filled in with the boundaries of the interval.
CODE(DOC_C(*)VAR(binfop)) is undefined at the end of an interval.
CODE(VAR(int_result)-&gt;stats) is always CODE(DOC_NULL).
When EOF is reached, the final partial interval is returned, and the
next call will return CODE(DOC_NULL).
</p>
<p>
See the section introduction above for
DOC_REF(more details, #cell-general) and
DOC_REF(return values, #cell-return).
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_block, DOC_TYPEREF(Source) *src,
    DOC_TYPEREF(Blk_info) **binfop, DOC_TYPEREF(atm_cell) **cellp,
    struct timeval *timeout)
DOC_DECL(DOC_TYPEREF(Iface) *coral_read_block_all,
    DOC_TYPEREF(Blk_info) **binfop, DOC_TYPEREF(atm_cell) **cellp,
    struct timeval *timeout)
:>)
<p>
The DOC_REF(cell reading functions, #DOC_ID(read_cell)) are usually more
convenient than these block reading functions.
</p>
<p>
After a successful read, the number of valid cells in the array pointed to by
CODE(*VAR(cellp)) is indicated by
CODE(ntohl((*VAR(binfop))-&gt;cell_count)),
the number of bytes (including padding) pointed to by
CODE(*VAR(cellp)) is indicated by
CODE(ntohl((*VAR(binfop))-&gt;blk_size)),
and the size of a cell is
CODE(DOC_REF(coral_cell_size, #DOC_TYPE(atm_cell))(VAR(iface))).
The VAR(n)th cell in the array pointed to by *VAR(cellp) which was
read from interface VAR(iface) can be found with the expression
CODE(DOC_IDREF(nth_cell)(iface, *cellp, n)).
</p>
:>)
</dl>

DOC_H4(Related Functions, cell-other)
<dl>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(atm_cell) *coral_nth_cell,
    const DOC_TYPEREF(Iface) *iface, DOC_TYPEREF(atm_cell) *blk, int n)
:>)
<p>
Returns a pointer to the VAR(n)th cell in the array of cells pointed
to by VAR(blk), which was read from VAR(iface).
(CODE(DOC_IDREF(nth_cell)()) is actually defined as a macro.)
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(<:void (*coral_cell_block_hook):>,
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Blk_info) *binfo)
:>)
<p>
If CODE(coral_cell_block_hook) is not CODE(DOC_NULL),
the function to which it
points will be called whenever a cell reading function or packet reading
function reads a new block of ATM cells.
VAR(iface) and VAR(binfo) will point to data about the new block.
The default value of CODE(DOC_IDREF(cell_block_hook)) is CODE(DOC_NULL).
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_proto_rule, const DOC_TYPEREF(Iface) *iface,
    uint32_t subif, DOC_TYPEREF(Protocol) *protop)
:>)
<p>
This function compares VAR(iface) and VAR(subif) (ATM vp:vc) against
the DOC_CMD_USAGE(CODE(proto), #proto)
and DOC_CMD_USAGE(CODE(deny), #deny)
configuration rules.
If they are denied by the rules, CODE(coral_proto_rule) returns 0.
Otherwise, it sets CODE(*VAR(protop)) to the
DOC_CMD_USAGE(protocol identifier, #protocols)
according to the rules, and returns&nbsp;1.
Cells that would be denied by the rules are never returned by the cell API,
but this function is still needed to find the protocol of the PDU to which
a cell belongs or to test for denial of a cell returned by the block API.
</p>
<p>
If there is no matching
DOC_CMD_USAGE(CODE(proto), #proto)
configuration rule for VAR(subif), and there is no default
protocol for VAR(iface),
the protocol for 0:0 through 0:15 defaults to
DOC_PROTO(PROTO_UNKNOWN),
the protocol for 0:16 defaults to
DOC_PROTO(DLT_ILMI),
and the protocol for all other virtual channels defaults to
DOC_PROTO(DLT_ATM_RFC1483).
</p>
<p>
Although DOC_IDREF(read_pkt) puts IEEE 802.1Q VLAN IDs
in the pkt_result-&gt;subif field, protocol rules should not be applied to
VLAN IDs.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_cell_to_pkt, const DOC_TYPEREF(Iface) *iface,
    DOC_TYPEREF(atm_cell) *cell, DOC_TYPEREF(Pkt_buffer) *pkt)
:>,<:
DOC_DECL(cell_to_pkt, SCALAR iface, DOC_TYPEREF(Cell) cell,
    DOC_TYPEREF(Pkt_buffer) pkt)

:>)
<p>
DOC_BOTH(
<:VAR(Cell) is a pointer to the first cell of an AAL5 PDU (in network
byte order).:>,
<:<var>cell</var> is a reference to a DOC_TYPEREF(Cell) object,
returned by DOC_IDREF(read_cell).:>
)
CODE(DOC_IDREF(cell_to_pkt)) fills in the object
DOC_BOTH(pointed to, referenced) by VAR(pkt) with
information from VAR(cell) and VAR(iface),
for use with functions that expect a
DOC_TYPEREF(Pkt_buffer) argument.
VAR(Iface) and the cell's vp:vc are used to determine the protocol of
the data according to the configuration
DOC_CMD_USAGE(CODE(proto), #proto) rules.
If VAR(iface) is CODE(DOC_NULL),
CODE(VAR(pkt)-&gt;protocol) will be set to
DOC_PROTO(PROTO_UNKNOWN).
</p>
<p>
The return value is 0 if 
VAR(iface) and the cell's vp:vc match a configuration
DOC_CMD_USAGE(CODE(deny), #deny) rule, otherwise 1.
</p>

DOC_PERL(<:
DOC_ENTRY(,<:
DOC_DECL(get_ip, SCALAR iface, REFERENCE data)
:>)
<p>
This Perl-only function is another shortcut for a common action:
taking a DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer)
and extracting the IPv4-level data from it.
<var>iface</var> is the interface from which the
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer) was read
(by DOC_IDREF(read_cell)() or
DOC_IDREF(read_pkt)()).
VAR(data) is a
reference to the
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer) itself.
Returns the byte string
data starting with the IPv4 header, or CODE(DOC_NULL) if there was any error.
(IP version != 4 counts as an error.)
The byte string can then be parsed by the
DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
</p>
:>)

</dl>

DOC_H3(Source and Interface Information, src-iface-info)
These functions provide information about CoralReef sources and interfaces.
<dl>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(const char *coral_file_version, const DOC_TYPEREF(Source) *src)
:>)
<p>
Returns a pointer to a static buffer containing a string describing a
file format version.
If VAR(src) corresponds to a tracefile,
the string describes the file format of the tracefile;
if VAR(src) is CODE(DOC_NULL),
the string describes the current file format (i.e., the highest format version
that this version of libcoral can read, and the format that would be written by
DOC_IDREF(write)() in this version of libcoral).
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Iface) *coral_next_interface,
    const DOC_TYPEREF(Iface) *iface)
DOC_DECL(DOC_TYPEREF(Source) *coral_next_source,
    const DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(next_interface, SCALAR iface)
DOC_DECL(next_source, SCALAR src)
:>)
<p>
If VAR(iface)/VAR(src) is CODE(DOC_NULL),
these functions return a pointer to the first CoralReef interface/source;
otherwise, they return a pointer to the interface/source following
VAR(iface)/VAR(src).
They return CODE(DOC_NULL) if there is no next interface/source.
The order in which interfaces/sources are returned
is not necessarily the order in which they were opened.
These functions are used to step through all interfaces/sources, for example:
</p>
<pre>DOC_BOTH(<:
    DOC_TYPEREF(Source) *src = NULL;
    while ((src = DOC_IDREF(next_source)(src))) {
        DOC_IDREF(dump)(src);
    }
:>, <:
    $iface = undef;
    while (($iface = DOC_IDREF(next_interface)($iface))) {
        # operate on iface 
    }
:>)
</pre>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Iface) *coral_next_src_iface,
    const DOC_TYPEREF(Source) *src, const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(next_src_iface, SCALAR src, SCALAR iface),
:>)
<p>
Like DOC_IDREF(next_interface)(), except it
only returns interfaces of VAR(src).
</p>

DOC_ENTRY(<:
DOC_DECL(const char *coral_source_get_filename,
    const DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(source_get_filename, SCALAR src)
:>)
<p>
Returns the name of the file or network interface of source VAR(src),
without a 
DOC_CMD_USAGE(coral type prefix, #sourcenames).
Returns CODE(DOC_NULL) if VAR(src) is bad.
</p>

DOC_ENTRY(<:
DOC_DECL(const char *coral_source_get_name,
    const DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(source_get_name, SCALAR src)
:>)
<p>
Returns the name of the source VAR(src),
including a
DOC_CMD_USAGE(coral type prefix, #sourcenames),
if any.
Returns CODE(DOC_NULL) if VAR(src) is bad.
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(const char *coral_source_get_comment,
    const DOC_TYPEREF(Source) *src)
:>)
<p>
Returns a pointer to the comment string from the file header of source
VAR(src).
Returns CODE(DOC_NULL) if VAR(src) is bad or there is no comment.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_get_source_count, void)
:>,<:
DOC_DECL(get_source_count, )
:>)
<p>
Returns the number of sources.
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Source) *coral_interface_get_src,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_src, SCALAR iface)
:>)
<p>
Returns DOC_BOTH(a pointer to, the source descriptor of) the source to which
interface VAR(iface) belongs, or CODE(DOC_NULL) if VAR(iface) is bad.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_interface_get_type, const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_type, SCALAR iface)
:>)
<p>
Return the <em>original</em> (hardware) type of interface VAR(iface),
or return DOC_CORAL(TYPE_NONE) if VAR(iface) is invalid or its type is unknown.
</p>

    <dl>
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_FATM), #fatm)
	<dd>FORE ATM adaptor device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_POINT), #point)
	<dd>Apptel POINT device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_DAG), #dag)
	<dd>Waikato DAG device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_PCAPLIVE), #pcaplive)
	<dd>pcap interface
    </dl>
<p>
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_source_get_type, const DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(source_get_type, SCALAR src)
:>)
<p>
Return the type of source VAR(src),
or DOC_CORAL(TYPE_NONE) if VAR(src) is invalid or its type is unknown.
For live sources, the type will be one of the types listed in the description
of DOC_IDREF(interface_get_type)();
for file sources, the type will be one of the following:
</p>
    <dl>
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_FILE), #crl)
	<dd>CoralReef trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_PCAP), #pcap)
	<dd>pcap (tcpdump) trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_DAGFILE), #dagfile)
	<dd>dagtools trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_TSH), #tsh)
	<dd>NLANR Time Sequenced Header trace file
    </dl>
<p>
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Protocol) coral_interface_get_datalink,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_datalink, SCALAR iface)
:>)
<p>
Return the data link layer type of interface VAR(iface),
or DOC_PROTO(PROTO_UNKNOWN)
if the protocol is unknown,
or -1 if VAR(iface) is bad.
The data link layer type is one of the DOC_PROTO(DLT_*) (layer 2) constants
defined in the
DOC_CMD_USAGE(Command Usage, #protocols) document.  
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Protocol) coral_interface_get_physical,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_physical, SCALAR iface)
:>)
<p>
Return the physical layer type of interface VAR(iface),
or DOC_PROTO(PROTO_UNKNOWN)
if the protocol is unknown,
or -1 if VAR(iface) is bad.
The physical layer type is one of the DOC_PROTO(PHY_*) (layer 1) constants
defined in the
DOC_CMD_USAGE(Command Usage, #protocols) document.  
</p>

DOC_ENTRY(<:
DOC_DECL(int32_t coral_interface_get_bandwidth,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_bandwidth, SCALAR iface)
:>)
<p>
Return the bandwidth (in kilobits per second) of interface VAR(iface),
or 0 if the bandwidth is unknown,
or -1 if VAR(iface) is bad.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_source_get_number, const DOC_TYPEREF(Source) *src)
DOC_DECL(int coral_interface_get_number,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(source_get_number, SCALAR src)
DOC_DECL(interface_get_number, SCALAR iface)
:>)
<p>
Return a non-negative integer identifier of
source VAR(src) or interface VAR(iface), or return -1 if
VAR(src) or VAR(iface) is bad.
The identifier returned is not really useful except as a label.
To print an interface number, see
DOC_IDREF(fmt_if_subif)().
</p>

DOC_ENTRY(<:
DOC_DECL(const struct timeval *coral_interface_get_capture_tv,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_capture_tv, SCALAR iface)
:>)
<p>
DOC_BOTH(
<:Returns a pointer to a structure containing the time (relative to the unix
epoch) of the start of the capture on interface VAR(iface),
or CODE(DOC_NULL) if there was an error.
The structure will contain 0,0:>,
<:Returns the time (relative to the unix epoch) of the start
of the capture on interface VAR(iface) in the form
of (sec, usec), or (undef, undef) if there was an error.
It will return (0,0):>
)
if the start time is unknown.
Note:  the microsecond component will always be 0 in traces in the old
DOC_CMD_USAGE(NLANR and MCI formats, #nlanr) and
DOC_CMD_USAGE(traces made with CoralReef, #crl)
versions prior to 3.2.2 (format version 9).
</p>

DOC_ENTRY(<:
DOC_DECL(time_t coral_interface_get_capturetime,
    const DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(interface_get_capturetime, SCALAR iface)
:>)
<p>
Returns the integer component of the value that would be returned by
CODE(DOC_IDREF(interface_get_capture_tv)(VAR(iface))).
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_ID(cell_size), const DOC_TYPEREF(Iface) iface)
:>,<:
DOC_DECL(DOC_ID(cell_size), SCALAR iface)
:>)
<p>
Returns the size of the cell structure used by <var>iface</var>. 
</p>

</dl>

DOC_H3(Timestamp Information, timestamp-info)
These functions get timestamps from packets and interpret them.
<dl>

DOC_PERL(<:
DOC_ENTRY(,<:
DOC_DECL(get_cell_timestamp, DOC_TYPEREF(Cell) cell)
:>)
<p>
Defunct.  The DOC_TYPEREF(Cell) object now has a member
called timestamp.<br />
Old call: CODE($stamp = DOC_IDREF(get_cell_timestamp)($cell);)<br />
New call: CODE($stamp = $cell-&gt;timestamp($iface);)<br />
</p>
:>)

DOC_LABEL(DOC_ID(read_clock))
DOC_ENTRY(<:
DOC_DECL(void coral_read_clock_timespec, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *t, struct timespec *ts)
DOC_DECL(void coral_read_clock_sec_nsec, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *t, time_t *sec, long *nsec)
DOC_DECL(double coral_read_clock_double, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *t)
DOC_DECL(void DOC_CORAL(TIMESTAMP_TO_TIMEVAL),
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t,
    struct timeval *tv)
DOC_DECL(void DOC_CORAL(TIMESTAMP_TO_TIMESPEC),
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t,
    struct timespec *ts):>,<:
DOC_DECL(DOC_ID(read_clock_sec_nsec), SCALAR iface, SCALAR t)
DOC_DECL(DOC_ID(read_clock_double), SCALAR iface, SCALAR t)
:>)
<p>
These functions parse the timestamp VAR(t), which belongs to a
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer)
read from interface VAR(iface), and convert it to a more useful
format.
</p>
<p>
If the DOC_OPT(NORMALIZE_TIME)
option is set, the result will be measured from the unix epoch;
otherwise, the result will have some interface-dependent epoch.
Normalization may introduce some error in the precision; this error will be
the same for all timestamps from the same interface, but may be different
for different interfaces.
</p>
<p>
These functions automatically correct the case in which the FORE card doesn't
increment the firmware clock because it misses a hardware clock wrap,
unless the DOC_OPT(FATM_RAW_TIME)
option is set.
</p>
<p>
CODE(DOC_IDREF(read_clock_double)()) returns the time
as floating point number of seconds.
Note that some precision may be lost by the conversion to double.
</p>

DOC_C(<:
<p>
CODE(DOC_IDREF(read_clock_timespec)()),
CODE(DOC_IDREF(read_clock_sec_nsec)()), and
CODE(DOC_CORAL(TIMESTAMP_TO_TIMEVAL)())
splits the time into two integers, seconds and residual fractions of a second,
and writes them into *VAR(tv), or *VAR(sec) and *VAR(nsec),
or *VAR(ts), respectively.
CODE(DOC_CORAL(TIMESTAMP_TO_TIMESPEC)) is identical to
CODE(DOC_IDREF(read_clock_timespec)),
for compatibility with earlier versions of libcoral.
</p>
:>)
DOC_PERL(<:
<p>
CODE(DOC_IDREF(read_clock_sec_nsec)())
returns the time as a 2-element list of seconds and nanoseconds.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(double coral_cell_time_double, const DOC_TYPEREF(Iface) *iface,
    DOC_TYPEREF(atm_cell) *cell)
:>)
<p>
Equivalent to CODE(DOC_IDREF(read_clock_double)(VAR(iface), DOC_IDREF(cell_time)(VAR(iface), VAR(cell)))).
</p>
:>)

</dl>

DOC_H3(Protocol Information, proto-info)
These functions manipulate protocol information.
<dl>

DOC_ENTRY(<:
DOC_DECL(const char *coral_proto_abbr, DOC_TYPEREF(Protocol) protocol)
DOC_DECL(const char *coral_proto_desc, DOC_TYPEREF(Protocol) protocol)
DOC_DECL(const char *coral_proto_str, DOC_TYPEREF(Protocol) protocol)
:>,<:
DOC_DECL(proto_abbr, NUM protocol)
DOC_DECL(proto_desc, NUM protocol)
DOC_DECL(proto_str, NUM protocol)
:>)
<p>
VAR(Protocol) is a CODE(DOC_CORAL(<var>prefix</var>_<var>name</var>))
constant (listed in the
DOC_CMD_USAGE(Command Usage, #protocols) document)
identifying a communication protocol.
These functions return a DOC_C(pointer to a )string describing protocol:
</p>
<ul>
<li>CODE(DOC_ID(proto_abbr)): a short name, or CODE(DOC_NULL);</li>
<li>CODE(DOC_ID(proto_desc)): a long description, or CODE(DOC_NULL);</li>
<li>CODE(DOC_ID(proto_str)): a long description, or "unknown VAR(N)".</li>
</ul>
<p>
</p>

DOC_ENTRY(<:
DOC_DECL(const char *coral_dns_op_to_str, uint8_t op)
DOC_DECL(const char *coral_dns_qtype_to_str, uint16_t qtype)
DOC_DECL(const char *coral_dns_qclass_to_str, uint16_t qclass)
:>,<:
DOC_DECL(dns_op_to_str, NUM qtype)
DOC_DECL(dns_qtype_to_str, NUM qtype)
DOC_DECL(dns_qclass_to_str, NUM qclass)
:>)
<p>
These functions return a DOC_C(pointer to a )string describing
DNS opcode VAR(op), qtype VAR(qtype), or qclass VAR(qclass),
respectively.
Strings are taken from
DOC_URL(http://www.iana.org/assignments/dns-parameters)
as of the time the library was written;
codes not present in that document are formatted as numbers.
The return value may point to a static data area that will be overwritten
with each call.
</p>

DOC_ENTRY(<:
DOC_DECL(uint8_t coral_dns_str_to_op, const char *str)
DOC_DECL(uint16_t coral_dns_str_to_qtype, const char *str)
DOC_DECL(uint16_t coral_dns_str_to_qclass, const char *str)
:>,<:
DOC_DECL(dns_str_to_op, STR str)
DOC_DECL(dns_str_to_qtype, STR str)
DOC_DECL(dns_str_to_qclass, STR str)
:>)
<p>
These functions return a code corresponding to VAR(str),
which is a string describing
a DNS opcode VAR(op), qtype VAR(qtype), or qclass VAR(qclass), respectively.
Strings are taken from
DOC_URL(http://www.iana.org/assignments/dns-parameters)
as of the time the library was written;
the return value for a string not present in that document is -1 (cast to the
return type).
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Protocol) coral_proto_id, const char *name)
:>,<:
DOC_DECL(proto_id, STR name)
:>)
<p>
Returns a protocol id constant (listed in the
DOC_CMD_USAGE(Command Usage, #protocols) document)
corresponding to VAR(name), which may be a short abbreviation or a
long description as returned by
DOC_REF(CODE(DOC_ID(proto)<:_{abbr,desc,str}():>), #DOC_ID(proto_abbr)).
Returns DOC_PROTO(PROTO_ILLEGAL) if VAR(name) is not a valid protocol name or
abbreviation.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_proto_layer, DOC_TYPEREF(Protocol) protocol)
:>,<:
DOC_DECL(proto_layer, NUM protocol)
:>)
<p>
Returns the layer number of VAR(protocol).
</p>
</dl>

DOC_C(<:
DOC_H4(vpvc macros, vpvc)
<dl>
<dt>Parameters:
<dd>
<dl compact="compact">
<dt>VAR(vpvc)	<dd>a variable containing a combined VPI and VCI.
<dt>VAR(vp)	<dd>a VPI (virtual path indicator)
<dt>VAR(vc)	<dd>a VCI (virtual channel indicator)
</dl>

<dt>Macros:
<dd>
<dl>
<dt>DOC_LABEL(get_vpvc_vp)
    CODE(<b>get_vpvc_vp</b>(VAR(vpvc)))
	<dd>returns the VPI of VAR(vpvc).
<dt>DOC_LABEL(get_vpvc_vc)
    CODE(<b>get_vpvc_vc</b>(VAR(vpvc)))
	<dd>returns the VCI of VAR(vpvc).
<dt>DOC_LABEL(set_vpvc_vp)
    CODE(<b>set_vpvc_vp</b>(VAR(vpvc), VAR(vp)))
	<dd>sets the VPI of VAR(vpvc).
<dt>DOC_LABEL(set_vpvc_vc)
    CODE(<b>set_vpvc_vc</b>(VAR(vpvc), VAR(vc)))
	<dd>sets the VCI of VAR(vpvc).
<dt>DOC_LABEL(vp_vc_to_vpvc)
    CODE(<b>vp_vc_to_vpvc</b>(VAR(vp), VAR(vc)))
	<dd>returns the combined value of VAR(vp) and VAR(vc).
</dl>
</dl>
:>)

</dl>

DOC_H3(Output File Rotation, DOC_ID(rotfile))
<p>
The rotating file API allows a programmer to write to a series of
files, occasionally changing the filename.  This can be useful for
long-running processes whose output you may want to read before
the process is complete, help with organizing output data, or simply
to keep output files at a manageable size.
It is usually fairly simple to convert existing code that writes to a
single file into code that writes to a rotating file by replacing
the open and close calls and possibly inserting rotation directives.
If you want the file to rotate every interval, you can use the
DOC_CORAL(ROT_AUTO) flag, and let libcoral handle everything for you;
if you want more control over when rotations occur, you can call the 
CODE(DOC_IDREF(rf_start)()) and CODE(DOC_IDREF(rf_end)())
functions yourself.
</p>
<p>
The functions:
</p>
<dl>

DOC_LABEL(DOC_ID(rf_open_*))
DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open_fd, int *fdp, const char *name, const char *tmp, uint8_t flags)
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open_file, FILE **filep, const char *name, const char *tmp, uint8_t flags)
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open_gzfile, DOC_IDREF(rf_info_gz_t) *fp, const char *name, const char *tmp, uint8_t flags)
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open_ogzfile, DOC_IDREF(rf_info_ogz_t) *fp, const char *name, const char *tmp, uint8_t flags)
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open_pcap_dump, DOC_IDREF(rf_info_pcap_dump_t) *fp, const char *name, const char *tmp, uint8_t flags)
:>,<:
DOC_DECL(rf_open_filehandle, REF handle, STR name, STR tmp = DOC_NULL, NUM flags = 0)
:>)
<p>
Creates a DOC_TYPEREF(Rotfile) object to be used for writing a series of files.
An iteration of the DOC_TYPEREF(Rotfile) can be started
either manually with CODE(DOC_IDREF(rf_start)()),
or automatically at the beginning of each interval
if VAR(flags) has the DOC_CORAL(ROT_AUTO) bit set.
When an iteration is started, the object
DOC_BOTH(<:pointed to:>, <:referenced:>) by the
DOC_BOTH(<:first:>, <:VAR(handle):>) parameter is filled in with a
DOC_BOTH(<:file descriptor, FILE pointer,
DOC_IDREF(rf_info_gz_t), DOC_IDREF(rf_info_ogz_t),
or DOC_IDREF(rf_info_pcap_dump_t):>,
<:filehandle:>).
Then, that value can be used as the destination of appropriate writing
functions.
</p>
<p>
VAR(Name) should contain % conversion specifiers; these will be replaced
each time the underlying file is rotated.
The following conversions are recognized:
</p>
<ul compact="compact">
<li>CODE(%i)	- iteration counter (starting at 0)
<li>CODE(%s)	- seconds (from the VAR(tv) parameter of
			CODE(DOC_IDREF(rf_start)()))
<li>CODE(%f)	- 6 digits of fractional seconds (from the VAR(tv)
			parameter of CODE(DOC_IDREF(rf_start)()))
<li>CODE(%F)	- equivalent to CODE(%Y-%m-%d) in strftime()
</ul>
<p>
All other % specifiers will be replaced as in strftime(),
using the VAR(tv) parameter of CODE(DOC_IDREF(rf_start)()).
Additionally, all specifiers other than CODE(%f) may contain any of the
modifiers allowed in CODE(%s) by printf (e.g., CODE("%03i")).
All specifiers other than CODE(%s) are formatted in the
local timezone according to the CODE(TZ) environment variable;
to use UTC instead, set CODE(TZ="UTC") in the environment.
</p>
<p>
If VAR(tmp) is DOC_NULL, a file with the specified name
is opened immediately with each call to CODE(DOC_IDREF(rf_start)());
otherwise, a temporary file is used, which is renamed to the specified
name when CODE(DOC_IDREF(rf_end)()) is called.
If VAR(tmp) is not "", it is used as the name of the temporary file;
if VAR(tmp) is "", a temporary name is generated automatically,
with the same directory as VAR(name).
</p>
<p>
To allow the programmer to write code that unconditionally uses
the DOC_IDREF(rf) functions for standard output as well as files,
the created rotfile object will behave differently
if VAR(name) is "-":
<ul>
<li>standard output will be associated with the created DOC_TYPEREF(Rotfile) object
<li>all calls to CODE(DOC_IDREF(rf_start)()) other than the first have no effect
<li>all calls to CODE(DOC_IDREF(rf_end)()) have no effect
<li>the VAR(tmp) parameter is ignored
</ul>
</p>
<p>
If VAR(flags) has the DOC_CORAL(ROT_AUTO) bit set,
the rotfile will rotate automatically at the beginning of every interval of
CODE(DOC_IDREF(read_pkt)) or CODE(DOC_IDREF(read_pkts)).
But if VAR(name) did not contain any "%" specifiers, only the first
(possibly implicit) interval
will cause an automatic CODE(DOC_IDREF(rf_start)) call; thus, without "%",
the file will not rotate every interval, but you still do not
need to call CODE(DOC_IDREF(rf_start)) manually before the first write.
Whatever the setting of DOC_CORAL(ROT_AUTO), you can still call
CODE(DOC_IDREF(rf_end)) and CODE(DOC_IDREF(rf_start)) to
manually rotate the rotfile.
But if VAR(flags) DOC_PERL(<:is undefined or :>)does not contain
DOC_CORAL(ROT_AUTO), or if you want to write to the rotfile
before the first interval, you must call CODE(DOC_IDREF(rf_start))
manually at least once before writing to the file.
</p>
<p>
If the filename generated from VAR(name) by CODE(DOC_IDREF(rf_start)) would
be a duplicate of a previously used name, it will automatically append
an iteration counter to the filename to avoid overwriting previous files.
This safety mechanism will be disabled if VAR(flags)
DOC_PERL(<:is defined and :>)has the DOC_CORAL(ROT_UNSAFE) bit set.
</p>
<p>
DOC_BOTH(These functions return, This function returns)
a DOC_BOTH(pointer, reference) to a newly created DOC_TYPEREF(Rotfile)
if successful; failure is indicated by returning DOC_NULL with DOC_errno set
and printing a DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
</p>
<p>
Typical rotating file code has this structure:
</p>
<pre>
    DOC_BOTH(
    <:FILE *file;
    DOC_TYPEREF(Rotfile) *rf;
    rf = DOC_IDREF(rf_open_file)(&file, name, NULL, 0);:>,
    <:my $handle = new IO::Handle;
    my $rf = DOC_IDREF(rf_open_filehandle)($handle, $name);:>)
    DOC_IDREF(rf_start)(DOC_VAR(rf));
    while (<i>there is data</i>) {
	if (<i>it is time to rotate the file</i>) {
	    DOC_IDREF(rf_end)(DOC_VAR(rf));
	    DOC_IDREF(rf_start)(DOC_VAR(rf));
	}
	DOC_BOTH(
	<:fputs(<i>data</i>, file);:>,
	<:print $handle <i>data</i>;:>)
    }
    DOC_IDREF(rf_close)(DOC_VAR(rf));
</pre>
<p>
If you wanted to rotate on interval boundaries, you could use the 
DOC_CORAL(ROT_AUTO) flag and omit the calls to
DOC_IDREF(rf_start) and DOC_IDREF(rf_end).
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Rotfile) *coral_rf_open, void *info, const char *name, const char *tmp, uint8_t flags, int (*open)(const char *name, void *info), int (*close)(void *info))
:>)
<p>
Like the DOC_IDREF(rf_open_*) functions,
DOC_IDREF(rf_open) creates a DOC_TYPEREF(Rotfile)
object to be used for writing a series of files.
The VAR(name), VAR(tmp), and VAR(flags) parameters are as described under
DOC_IDREF(rf_open_fd).
The VAR(open) and VAR(close) parameters are callback functions that are
called by DOC_IDREF(rf_start) and DOC_IDREF(rf_end), respectively;
these allow you to define custom functions to operate on any file type,
instead of just the predefined types used by DOC_IDREF(rf_open_*).
The VAR(info) parameter is like the first parameter of DOC_IDREF(rf_open*),
except the type of the object to which it points is defined by the
VAR(open) and VAR(close) parameters.
</p>
<p>
Whenever the rotfile needs to rotate, it uses the VAR(open) and VAR(close)
callback functions to open and close the real file.
VAR(info) is a pointer to whatever data is required by the callback functions.
The object to which VAR(info) points must remain valid for the lifetime
of the rotfile.
DOC_Name provides several pairs of useful callback functions of the form:<br />
<code>
DOC_DECL(int DOC_ID(rf_cb_open_<::>VAR(filetype)), const char *name, void *info)
DOC_DECL(int DOC_ID(rf_cb_close_<::>VAR(filetype)), void *info)
</code>
</p>

<table border="1">
<tr>
<td>VAR(filetype)
<td>info type
<td>description
<tr>
<tr>
<td>CODE(fd)
<td>int*
<td>Opens a file descriptor, stored in CODE(*info).
<tr>
<td>CODE(file)
<td>FILE**
<td>Opens a stdio FILE, stored in CODE(*info).
<tr>
<td>CODE(gzfile)
<td>DOC_TYPEREF(rf_info_gz)*
<td>Opens a gzipped file.  You must set CODE(info->mode) before opening.
    The file pointer is stored in CODE(info->gzfile).
<tr>
<td>CODE(ogzfile)
<td>DOC_TYPEREF(rf_info_ogz)*
<td>Opens a gzipped file if the file's name ends in CODE(".gz") or if the
    global gzip option was set with the "DOC_CMD_USAGE(gzip, #gzip)" command
    or DOC_IDREF(set_gzip)(), otherwise it opens an uncompressed file.
    To write to an ogzfile, you must use the CODE(DOC_IDREF(rf_ogz_*))
    functions.
<tr>
<td>CODE(pcap_dump)
<td>DOC_TYPEREF(rf_info_pcap_dump)*
<td>Opens a pcap file.  You must set CODE(info->pcap) before opening.
    The file pointer is stored in CODE(info->pcap_dumper).  
    Opens a gzipped file if the file's name ends in CODE(".gz") or if the
    global gzip option was set with the "DOC_CMD_USAGE(gzip, #gzip)" command
    or DOC_IDREF(set_gzip)(), otherwise it opens an uncompressed file.
</table>
<p>
These five pairs of callbacks are used to implement the
DOC_IDREF(rf_open_*) functions.
The CODE(gzfile) and CODE(ogzfile) callbacks will be available only if a
good version of libz was found when libcoral was compiled.
</p>
<p>
You can also pass pointers to your own VAR(open) and VAR(close) functions
that open different kinds of files and/or write headers or trailers
on the files.  In this way, you can have custom rotating files that have
the same filename formatting and other features of the standard DOC_name
rotfile types.  Any open function passed to CODE(DOC_ID(rf_open()))
must handle the "-" filename.
</p>
<p>
If it is possible to write your open function to work with a file descriptor
or FILE* instead of the filename, you can make it call
CODE(DOC_ID(rf_cb_open_fd())) or CODE(DOC_ID(rf_cb_open_file()))
to be sure it behaves the same way (e.g., for handling the filename "-").
For example, CODE(DOC_ID(rf_cb_open_file())) is actually a very simple function
that calls CODE(DOC_ID(rf_cb_open_fd())) and then passes the resulting file
descriptor to CODE(fdopen()).
</p>
<p>
The following example of a custom open function uses
CODE(DOC_ID(rf_cb_open_file()))
to open a regular file, and also writes a header at the top of each rotated
file.  This is the easiest way to guarantee that the header will be written
exactly once at the start of each iteration, even if the rotfile
doesn't actually rotate (because it is directed to stdout, for example).
</p>
<pre>
int open_outfile(const char *name, void *info)
{
    FILE *file;
    if (DOC_ID(rf_cb_open_file)(name, info) < 0) return -1;
    file = *(FILE**)info;
    fprintf(file, "%17s %7s %7s\n", "start", "pkts", "bytes");
    return 0;
}
</pre>

</p>
<p>
CODE(DOC_ID(rf_open)())
returns a DOC_BOTH(pointer, reference) to a newly created DOC_TYPEREF(Rotfile)
if successful; failure is indicated by returning DOC_NULL with DOC_errno set
and printing a DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
</p>
:>) dnl end DOC_C

DOC_C(<: dnl begin rotfile C-only block
DOC_LABEL(DOC_ID(rf_ogz_*))
DOC_ENTRY(<:
DOC_DECL(void *coral_rf_ogz_write, DOC_TYPEREF(rf_info_ogz) *info, const void *buf, size_t len)
DOC_DECL(void *coral_rf_ogz_seek, DOC_TYPEREF(rf_info_ogz) *info, off_t offset, int whence)
DOC_DECL(void *coral_rf_ogz_flush, DOC_TYPEREF(rf_info_ogz) *info)
:>)
<p>
These functions are used to operate on VAR(info), which must point to a
DOC_TYPEREF(rf_info_ogz) opened by
CODE(DOC_IDREF(rf_open_ogzfile)()) or
CODE(DOC_IDREF(rf_cb_open_ogzfile)()).
They are similar to their standard C counterparts, except that
they take a pointer to a DOC_TYPEREF(rf_info_ogz) instead of a file descriptor.
Unlike fseek(), CODE(DOC_IDREF(rf_ogz_seek)()) will work on a pipe open
for writing, if whence == SEEK_CUR and offset >= 0.
Remember that CODE(DOC_IDREF(rf_ogz_seek)()) followed by
CODE(DOC_IDREF(rf_ogz_close)()) will not write trailing zeros to the file
(just like fseek() followed by fclose() on a standard file).
</p>
<p>
Prior to CoralReef version 3.9.0, the offset parameter to 
CODE(DOC_IDREF(rf_ogz_seek)()) was a long, not an off_t.
</p>
:>) dnl end rotfile C-only block

DOC_C(<: dnl begin rotfile C-only block
DOC_ENTRY(<:
DOC_DECL(void *coral_rf_info, DOC_TYPEREF(Rotfile) *rf)
:>)
<p>
Returns
the first parameter that was passed in to the
DOC_BOTH(
<:CODE(DOC_IDREF(rf_open*)()):>,
<:CODE(DOC_IDREF(rf_open_filehandle)()):>
)
function that created VAR(rf).
</p>
:>) dnl end rotfile C-only block

DOC_ENTRY(<:
DOC_DECL(int coral_rf_start, DOC_TYPEREF(Rotfile) *rf, const struct timeval *tv)
:>,<:
DOC_DECL(rf_start, DOC_TYPEREF(Rotfile) rf, LIST REF tv)
:>)
<p>
Starts an iteration of rotating file VAR(rf) which has been opened by
DOC_BOTH(
<:one of the CODE(DOC_IDREF(rf_open)) functions:>,
<:CODE(DOC_IDREF(rf_open_filehandle)()):>
).
The filename is fixed at this point
using the time value in VAR(tv) for the strftime expansion.
DOC_PERL(<:VAR(tv) is a reference to a 2-element array representing the
seconds and microseconds time value.:>)
If VAR(tv) is CODE(DOC_NULL), the current time is used.
If temporary files were requested when VAR(rf) was opened, this filename
is not actually used yet, it is just recorded for later use.
Next, a real file is actually opened, unless the filename was "-"
and this is not the first call to CODE(DOC_IDREF(rf_start)).
If a disk file is opened,
it will have mode 666 modified by the process umask.
Returns 0 for success;
failure is indicated by returning -1 with DOC_errno set and printing a
DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
</p>
DOC_C(<:
<p>
See CODE(DOC_IDREF(rf_start_name)) and CODE(DOC_IDREF(rf_start_output))
for a fork-safe equivalent of this function.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_rf_start_name, DOC_TYPEREF(Rotfile) *rf, const struct timeval *tv)
:>,<:
DOC_DECL(rf_start_name, DOC_TYPEREF(Rotfile) rf, LIST REF tv)
:>)
DOC_ENTRY(<:
DOC_DECL(int coral_rf_start_output, DOC_TYPEREF(Rotfile) *rf)
:>,<:
DOC_DECL(rf_start_output, DOC_TYPEREF(Rotfile) rf, LIST REF tv)
:>)
<p>
These two functions provide a fork-safe equivalent to CODE(DOC_IDREF(rf_start)),
which is useful if you want to use a child process to write output for one
interval so the parent process can begin processing the next interval
immediately.
Before forking, you should call CODE(DOC_IDREF(rf_start_name)).
After forking, in the child process, you should
call CODE(DOC_IDREF(rf_start_output)), do your writing, and eventually
call CODE(DOC_IDREF(rf_end)) and CODE(_exit()).
You should not call CODE(DOC_IDREF(rf_end)) in the parent.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_rf_end, DOC_TYPEREF(Rotfile) *rf)
:>,<:
DOC_DECL(rf_end, DOC_TYPEREF(Rotfile) rf)
:>)
<p>
Ends an iteration of VAR(rf) by
closing the real file associated with this iteration of the rotfile,
unless the filename was "-".
If temporary files were requested when VAR(rf) was opened, the
file that was created by CODE(DOC_IDREF(rf_start)())
is now renamed to the permanent file name.
The iteration counter of VAR(rf) is incremented (this counter appears
in place of "%i" in the filename created by CODE(DOC_IDREF(rf_start)())).
Writing to the file associated with rotfile 
is not allowed until VAR(rf) is started again with CODE(DOC_IDREF(rf_start)()).
If the filename was "-", or
CODE(DOC_IDREF(rf_start)(VAR(rf))) has not been called since
VAR(rf) was opened or ended,
this function has no effect.
Returns 0 for success;
failure is indicated by returning -1 with DOC_errno set and printing a
DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_rf_close, DOC_TYPEREF(Rotfile) *rf)
:>,<:
DOC_DECL(rf_close, DOC_TYPEREF(Rotfile) rf)
:>)
<p>
Implicitly calls CODE(DOC_IDREF(rf_end)(VAR(rf))) if necessary,
and deallocates all resources associated with VAR(rf).
To guarantee that all data is actually written to a file,
it is important to call DOC_ID(rf_close) before exiting the program.
Returns 0 for success;
failure is indicated by returning -1 with DOC_errno set and printing a
DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_rotate_errfile, const struct timeval *tv)
:>,<:
DOC_DECL(rotate_errfile, LIST REF tv)
:>)
<p>
Rotates the DOC_REF(error file, #DOC_ID(set_errfilename))
(if the configured error file name contained "%"),
using VAR(tv) as the timestamp for substitutions in the filename
as in CODE(DOC_IDREF(rf_start)()).
Returns 0 for success;
failure is indicated by returning -1 with DOC_errno set and printing a
DOC_BOTH(<:message with CODE(DOC_IDREF(diag)()).:>, message.)
If rotation fails, the error file resets to stderr.
</p>

</dl>

DOC_H3(CRL Trace Writing, DOC_ID(write))
<p>
The writing API allows a programmer to copy cells or blocks from a CoralReef
source to a CoralReef-format trace file.  The source is typically a OCx device
(for doing data capture), but may also be another trace file (useful for
encoding, or converting from another format).
</p>
<p>
For information on writing <em>packets</em> in pcap format, see the section on
DOC_REF(pcap conversion, #pcap).
</p>
<dl>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Writer) *coral_write_open, const char *name)
:>,<:
DOC_DECL(write_open, STR name, STR comment = undef, STR encoding = undef,
    NUM version = 0)
:>)
<p>
Open file VAR(name) for writing a trace file in CoralReef format.
If the name ends in CODE(".gz") or the
"DOC_CMD_USAGE(gzip, #gzip)" configuration option was
given, and CoralReef was compiled with libz, the file will be gzipped.
(DOC_IDREF(set_api)() must be called with the DOC_CORAL(API_WRITE) bit
to enable the "DOC_CMD_USAGE(gzip, #gzip)" configuration option.)
A leading CODE(~) in VAR(name) is expanded to a home directory.
If the name is CODE("-"), data will be written to stdout.
Returns a DOC_BOTH(pointer to a coral writer, coral write descriptor (writer))
for success, CODE(DOC_NULL) for failure.
The recommended suffix for CoralReef trace files is ".crl", and for encoded
CoralReef trace files is ".enc.crl".
</p>
DOC_PERL(<:
<p>
Writes <var>comment</var> and <var>encoding</var> strings into the
file header, with encoding version set to <var>version</var>.
<var>Comment</var> and <var>encoding</var> default to
undef, <var>version</var> defaults to 0.
<var>Comment</var> may be up to 255 characters,
<var>encoding</var> may be up to 31 characters.
</p>
:>)
<p>
To ensure that all data from all sources are read, you must call
CODE(DOC_IDREF(stop)())
on any sources which have not reached EOF.
Then, to ensure that all data from all sources are written, you must call
CODE(DOC_IDREF(write_close)())
on the writer, before calling
CODE(DOC_IDREF(close)())
on the sources.
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Writer) *coral_write_rfopen, const char *name, const char *tmp)
:>,<:
DOC_DECL(write_rfopen, STR name, STR tmp = undef, STR comment = undef,
    STR encoding = undef, NUM version = 0)
:>)
<p>
Like CODE(DOC_IDREF(write_open)()), except the file can be rotated.
The file name should contain % escapes; these will get expanded with
every rotation.  The legal escapes are the same as those in
CODE(DOC_IDREF(rf_open)()).
The underlying file is not actually opened until
CODE(DOC_IDREF(rf_start)()) or the first write;
the timestamp used in filename expansion is the current time.
Use CODE(DOC_IDREF(write_end)()) to end the current iteration
of a file; a new iteration will be started with the next
CODE(DOC_IDREF(rf_start)()) or write.
Use CODE(DOC_IDREF(write_close)()) when done writing to the file;
it will do an implicit CODE(DOC_IDREF(write_end)()) if one has
not been done since the last CODE(DOC_IDREF(rf_start)()) or write.
If VAR(tmp) is not DOC_NULL, the current iteration file will be given a
temporary name, which will be renamed to the permanent name
by CODE(DOC_IDREF(write_end)()); this guarantees that files matching
VAR(name) are always complete.  If VAR(tmp) is not "", it is used as
the temporary name; if it is "", a temporary name is generated automatically,
with the same directory as VAR(name).
</p>

DOC_ENTRY(<:
DOC_DECL(DOC_TYPEREF(Writer) *coral_write_fdopen, int fd)
:>,<:
DOC_DECL(write_fopen, FILEHANDLE file, STR comment = undef,
    STR encoding = undef, NUM version = 0)
:>)
<p>
Like DOC_IDREF(write_open), except it uses
the already-open file DOC_BOTH(descriptor VAR(fd), handle VAR(file))
instead of a filename.
</p>
<p>
Mixing CoralReef operations with other operations
on DOC_BOTH(descriptor VAR(fd), handle VAR(file)) may have unpredictable
effects.
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(const char *coral_write_get_name, DOC_TYPEREF(Writer) *writer)
:>,<:
DOC_DECL(write_get_name, SCALAR writer)
:>)
<p>
Returns the filename used to open VAR(writer).
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_write_set_comment, DOC_TYPEREF(Writer) *writer,
    const char *comment)
DOC_DECL(int coral_write_set_encoding, DOC_TYPEREF(Writer) *writer,
    const char *encoding)
:>)
<p>
These functions set the comment or encoding strings that will be written
into the file header of VAR(writer).
The string parameters are null-terminated strings;
VAR(comment) may be up to 255 characters,
VAR(encoding) may be up to 31 characters.
These functions return 0 for success, -1 for failure.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_write_init_all, DOC_TYPEREF(Writer) *writer)
DOC_DECL(int coral_write_init_source, DOC_TYPEREF(Writer) *writer,
    DOC_TYPEREF(Source) *src)
:>,<:
DOC_DECL(write_init_all, SCALAR writer)
DOC_DECL(write_init_source, SCALAR writer, SCALAR src)
:>)
<p>
Prepare to write data from the indicated sources to VAR(writer).
Returns 0 for success, -1 for failure.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_write_init_interface, DOC_TYPEREF(Writer) *writer,
    DOC_TYPEREF(Iface) *iface)
:>,<:
DOC_DECL(write_init_interface, SCALAR writer, SCALAR iface)
:>)
<p>
Prepare to write data from a single interface VAR(iface) to tracefile
VAR(writer).  Returns 0 for success, -1 for failure.
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_write_cells, DOC_TYPEREF(Writer) *writer,
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(atm_cell) *cell,
    int count)
:>,<:
DOC_DECL(write_cell, SCALAR writer, SCALAR iface, SCALAR cell)
:>)
<p>
Write DOC_C(an array of VAR(count) cells pointed to by )VAR(cell)
to VAR(writer).
VAR(iface) indicates which interface the DOC_BOTH(cells were, cell was)
read from
(as returned by a CoralReef DOC_REF(reading function, #DOC_ID(read_cell))).
Returns 0 for success, -1 for failure.
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_write_block, DOC_TYPEREF(Writer) *writer,
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Blk_info) *binfo,
    const DOC_TYPEREF(atm_cell) *blk)
:>)
<p>
Write a block of cells pointed to by VAR(blk)
with block info VAR(binfo) to VAR(writer).
The structure pointed to by VAR(binfo) must be in network byte order.
VAR(iface) indicates which interface the cells were read from
(as returned by a CoralReef reading function).
This function is more efficient than CODE(DOC_IDREF(write_cells)()).
Returns 0 for success, -1 for failure.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_write_close, DOC_TYPEREF(Writer) *writer)
:>,<:
DOC_DECL(write_close, SCALAR writer)
:>)
<p>
Close the coral trace indicated by VAR(writer).
Returns 0 for success, -1 for failure.
To ensure that all data from all sources are read, you must call
CODE(DOC_IDREF(stop)())
on any sources which have not reached EOF.
To ensure that all data from all sources are written, you must call
CODE(DOC_IDREF(write_close)())
on the writer, before calling
CODE(DOC_IDREF(close)())
on the sources.
</p>

</dl>

DOC_C(<:
DOC_H4(Trace writing example, coral_write-ex)
<pre>
int main(int argc, char *argv[]) {
    DOC_TYPEREF(Writer) *writer;
    DOC_TYPEREF(Iface) *iface;
    DOC_TYPEREF(atm_cell) *blk;
    DOC_TYPEREF(Blk_info) *binfo;

    DOC_IDREF(set_duration)(60);
    if (DOC_IDREF(config_arguments)(argc, argv) &lt; 0)
	exit(2);
    writer = DOC_IDREF(write_open)("out.crl");
    if (!writer)
        exit(3);
    if (DOC_IDREF(write_init_all)(writer) &lt; 0)
        exit(4);
    if (DOC_IDREF(start_all)() &lt; 0)
        exit(5);

    while ((iface = DOC_IDREF(read_block_all)(&amp;binfo, &amp;blk, NULL))) {
        if (DOC_IDREF(write_block)(writer, iface, binfo, blk) &lt; 0)
            exit(6);
    }

    DOC_IDREF(stop_all)();
    DOC_IDREF(write_close)(writer);
    DOC_IDREF(close_all)();
}
</pre>
:>)

DOC_C(<:
DOC_H3(Pcap (tcpdump) Conversion, pcap)
<p>
These functions convert CoralReef structures to pcap structures, so they
may be used with pcap and BPF functions.  To use these functions,
the pcap header must be included:
</p>
<pre>
	#include &lt;pcap.h&gt;
</pre>

<dl>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(pcap_t *coral_iface_to_pcapp, DOC_TYPEREF(Iface) *iface)
DOC_DECL(pcap_t *coral_iface_to_pcapp_raw, DOC_TYPEREF(Iface) *iface)
:>)
<p>
Returns a pointer to a pcap_t containing information copied from
*VAR(iface),
or returns CODE(DOC_NULL) if there is an error.
If <b>coral_iface_to_pcapp_raw</b> is called, or <b>coral_iface_to_pcapp</b>
is called but VAR(iface) uses a data link layer protocol not supported
by pcap, the created pcap_t structure will be set to DLT_RAW (raw IP), and
DOC_IDREF(pkt_to_pcap)() calls on the pcap_t
will strip encapsulation from IP packets and discard non-IP packets.
</p>
<p>
The caller must not CODE(pcap_close()) or CODE(free()) the
resulting pcap_t; libcoral will do this automatically when VAR(iface)
is closed.
(Prior to version 3.4, it was the caller's responsibility to free the pcap_t.)
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_iface_to_pcap, const DOC_TYPEREF(Iface) *iface,
    pcap_t *pcap)
:>)
<p>
Obsolete.  See DOC_IDREF(iface_to_pcapp)().
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_pkt_to_pcap, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, const DOC_TYPEREF(Pkt_buffer) *pkt,
    pcap_t *pcap, struct pcap_pkthdr *hdr)
:>)
<p>
Parameters:
</p>
<dl>
<dt>VAR(iface) 
    <dd>A pointer to a coral interface from which VAR(pkt) was read
<dt>VAR(timestamp)
    <dd>A pointer to the timestamp of VAR(pkt)
<dt>VAR(pkt)
    <dd>A pointer to a packet that was read from VAR(iface)
<dt>VAR(pcap)
    <dd>A pointer to a pcap structure returned by
    DOC_IDREF(iface_to_pcapp)() or
    DOC_IDREF(iface_to_pcapp_raw)()
<dt>VAR(hdr)
    <dd>A pointer to a pcap_pkthdr which will be filled in by the call
</dl>
<p>
This function
fills in *VAR(hdr) with information from
*VAR(iface), *VAR(timestamp), and *VAR(pkt).
If *VAR(timestamp) is not CODE(DOC_NULL),
its value will be normalized to the unix epoch and copied to
CODE(VAR(hdr)-&gt;ts);
otherwise, CODE(VAR(hdr)-&gt;ts) will be set to zero.
(The timestamp was not normalized in versions before 3.2.2.)
</p>
<p>
The linktype of VAR(pcap) must be either CODE(DLT_RAW)
or compatible with the protocol of VAR(iface).
The former condition is true if VAR(pcap) was created by calling
DOC_IDREF(iface_to_pcapp_raw)().
The latter condition is true if VAR(pcap) was created by calling
DOC_IDREF(iface_to_pcapp)() on
VAR(iface) or another coral interface with the same protocol
as VAR(iface).
</p>
<p>
If the linktype of VAR(pcap) is compatible with the protocol of
VAR(iface), this function simply copies and converts the information
into VAR(hdr), and returns 0.
</p>
<p>
If the linktype of VAR(pcap) is CODE(DLT_RAW),
this function will strip off the encapsulation to find an IP packet.
If there is no IP packet, this function returns -1.
If there is an IP packet, this function returns the offset of that IP packet
within CODE(VAR(pkt)-&gt;buf), and fills in the rest of
VAR(hdr) with information about the IP packet, not the original packet.
</p>
<p>
This function returns -1 to indicate an error or that the packet could not
be converted to pcap form.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_write_pkt_to_pcap, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, const DOC_TYPEREF(Pkt_buffer) *pkt,
    pcap_t *pcap, struct pcap_dumper_t *pcap_dumper)
:>)
<p>
This function calls DOC_IDREF(pkt_to_pcap)()
to convert the CoralReef packet VAR(pkt) to a pcap packet,
and writes it to VAR(pcap_dumper) with CODE(pcap_dump()).
</p>
:>)


DOC_C(<:
</dl>

DOC_H4(Example, pcap-ex)
<p>
This example reads packets from a CoralReef interface and writes them to a
tcpdump file.
</p>
<pre>
	pcap_t *pcap;
	struct pcap_pkthdr pcap_hdr;
	int offset;

	/* ... */

	pcap = DOC_IDREF(iface_to_pcapp)(iface);
	if (!pcap)
	    /* handle error */;
	pcap_dumper = pcap_dump_open(pcap, filename);

	/* ... */

	iface = DOC_IDREF(read_pkt)(&amp;pkt_result, &amp;interval_result);
	if (!iface)
	    /* handle error */;
	offset = DOC_IDREF(pkt_to_pcap)(iface, pkt_result.timestamp,
	    pkt_result.packet, &amp;pcap_hdr);
	if (offset &lt; 0)
	    /* handle error */;
	pcap_dump(pcap_dumper, &amp;pcap_hdr, pkt_result.packet-&gt;buf + offset);
</pre>
<p>
Note: in the example above, it is possible to open a pcap dumper for coral
interface A, and then dump packets to it that were read from coral interface B.
This is ok only if interfaces A and B have the same data link type, bandwidth,
and other properties; otherwise,
DOC_IDREF(pkt_to_pcap)()
will return an error without writing the incompatible packet.
</p>
:>)

DOC_C(<:
DOC_LABEL(crl_htobes, crl_htobel, crl_htobe64)
DOC_LABEL(crl_betohs, crl_betohl, crl_betoh64)
DOC_LABEL(crl_htoles, crl_htolel, crl_htole64)
DOC_LABEL(crl_letohs, crl_letohl, crl_letoh64)
DOC_LABEL(crl_htons, crl_htonl, crl_hton64)
DOC_LABEL(crl_ntohs, crl_ntohl, crl_ntoh64)
DOC_H3(Byte order macros, byteorder)
<p>
The header CODE(&lt;crl_byteorder.h&gt;) defines a set of macros
for manipulating the byte order of 16, 32, and 64 bit integer values.
CODE(BYTE_ORDER) or CODE(WORDS_BIGENDIAN) must be defined
when CODE(&lt;crl_byteorder.h&gt;) is included.
CODE(BYTE_ORDER) is defined in CODE(&lt;sys/param.h&gt;)
on some platforms,
and CODE(WORDS_BIGENDIAN) is defined by CODE(&lt;coral-config.h&gt;) or can be
defined by a GNU configure script.
These macros can be optimized to a compile-time constant when their
parameter is a compile-time constant.
</p>

<p>
Each macro with a name of the form <b>crl_<i>src</i>to<i>dst</i><i>type</i></b>
takes one integer parameter in byte order indicated by <i>src</i>
and returns an integer in byte order type indicated by <i>dst</i>.
The type of the parameter is indicated by <i>type</i>.
The following byte order macros are defined:
</p>

<table border=1>
<tr><td><td colspan=3 align="center">type of parameter and result
<tr><td>byte order conversion  <td>uint16_t            <td>uint32_t            <td>uint64_t
<tr>
<tr><td>host to big endian     <td><b>crl_htobes</b>   <td><b>crl_htobel</b>   <td><b>crl_htobe64</b>
<tr><td>big endian to host     <td><b>crl_betohs</b>   <td><b>crl_betohl</b>   <td><b>crl_betoh64</b>
<tr><td>host to little endian  <td><b>crl_htoles</b>   <td><b>crl_htolel</b>   <td><b>crl_htole64</b>
<tr><td>little endian to host  <td><b>crl_letohs</b>   <td><b>crl_letohl</b>   <td><b>crl_letoh64</b>
<tr><td>host to network        <td><b>crl_htons</b>    <td><b>crl_htonl</b>    <td><b>crl_hton64</b>
<tr><td>network to host        <td><b>crl_ntohs</b>    <td><b>crl_ntohl</b>    <td><b>crl_ntoh64</b>
</table>
<p></p>

<dl>
DOC_LABEL(crl_nptohs, crl_nptohl)
DOC_ENTRY(<:
DOC_DECL(uint16_t crl_nptohs, void *p)
DOC_DECL(uint32_t crl_nptohl, void *p)
:>)
<p>
Converts the value pointed at by VAR(p) from network order to host order.
The value pointed at by VAR(p) does not need to be aligned, so these are
safe to use on fields within packets returned by libcoral.
</p>

</dl>
:>)

DOC_H3(Formatted printing, printing)
<dl>

DOC_ENTRY(<:
DOC_DECL(int coral_puts, const char *str)
:>,<:
DOC_DECL(puts, STR str)
:>)
<p>
Like the standard C function CODE(puts(str)), except that it prints to the
CoralReef DOC_REF(errfile, #DOC_ID(get_errfile)) instead of stdout,
and it is guaranteed to not modify CODE(errno).
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_printf, const char *fmt, ...)
:>)
<p>
Like CODE(printf(fmt, ...)),
except that it prints to the CoralReef DOC_REF(errfile, #DOC_ID(get_errfile)) instead of stdout,
and it is guaranteed to not modify CODE(errno).
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(void coral_diag, int level, <:(const char *fmt, ...):>)
:>)
<p>
Like CODE(DOC_IDREF(printf)(fmt, ...)),
except that nothing will be printed if
CODE(VAR(level) &gt; DOC_IDREF(get_verbosity)()).
Returns void.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(void coral_fprint_data, FILE *file, int indent,
    const u_char *data, size_t len)
DOC_DECL(void coral_print_data, int indent, const u_char *data,
    size_t len)
:>,<:
DOC_DECL(fprint_data, FILEHANDLE file, NUM indent, SCALAR data, NUM len)
DOC_DECL(print_data, NUM indent, SCALAR data, NUM len)
:>)
<p>
CODE(DOC_IDREF(print_data)) prints VAR(len) bytes from VAR(data)
to CODE(stdout) in a easily readable format:
16 hex values per line, with each line indented VAR(indent) spaces.
CODE(DOC_IDREF(fprint_data)) is like
CODE(DOC_IDREF(print_data)), except
it prints to VAR(file) instead of CODE(stdout).
</p>

DOC_ENTRY(<:
DOC_DECL(void coral_fprint_cell, FILE *file, int indent,
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(atm_cell) *cell)
DOC_DECL(void coral_print_cell, int indent,
    const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(atm_cell) *cell)
:>,<:
DOC_DECL(fprint_cell, FILEHANDLE file, NUM indent, SCALAR iface,
    SCALAR cell)
DOC_DECL(print_cell, NUM indent, SCALAR iface, SCALAR cell)
:>)
<p>
DOC_ID(print_cell)
prints VAR(cell) (which was read from VAR(iface)) to CODE(stdout)
in an easily readable format, with the timestamp in seconds, the
ATM header expanded by fields, and the payload in hex,
with each line indented VAR(indent) spaces.
This format is used by the application DOC_APP(crl_print).
CODE(DOC_IDREF(fprint_cell)) is like CODE(DOC_IDREF(print_cell)), except
it prints to VAR(file).
</p>

DOC_ENTRY(<:
DOC_DECL(void coral_fmprint_pkt, FILE *file, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, int minlayer, int maxlayer,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
:>,<:
DOC_DECL(fmprint_pkt, FILEHANDLE file, SCALAR iface, SCALAR timestamp,
    NUM minlayer, NUM maxlayer, DOC_TYPEREF(Pkt_buffer) packet,
    DOC_TYPEREF(Pkt_buffer) header, DOC_TYPEREF(Pkt_buffer) trailer)
:>)
<p>
CODE(DOC_ID(fmprint_pkt)) prints VAR(packet) and optionally
VAR(header) and VAR(trailer)
(which were read from VAR(iface)) to VAR(file)
in an easily readable format, with the timestamp in seconds.
Protocol layers less than VAR(minlayer) will be skipped;
layers between VAR(minlayer) and VAR(maxlayer) will be
expanded by fields in an easily readable format,
as by CODE(DOC_IDREF(fmt_get_payload)());
layers greater than VAR(maxlayer) or not understood by libcoral
will be printed in hex.
This format is used by the application DOC_APP(crl_print_pkt).
</p>

DOC_ENTRY(<:
DOC_DECL(void coral_fprint_pkt, FILE *file, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, int maxlayer,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
:>,<:
DOC_DECL(fprint_pkt, FILEHANDLE file, SCALAR iface,
    SCALAR timestamp, NUM maxlayer,
    DOC_TYPEREF(Pkt_buffer) packet, DOC_TYPEREF(Pkt_buffer) header,
    DOC_TYPEREF(Pkt_buffer) trailer)
:>)
<p>
Equivalent to
CODE(DOC_IDREF(fmprint_pkt)(VAR(iface), VAR(timestamp),
1, VAR(maxlayer), VAR(packet),
VAR(header), VAR(trailer))).
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(void coral_mprint_pkt, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, void *layerp,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
DOC_DECL(void coral_print_pkt, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, void *layerp,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
:>)
<p>
These functions are like CODE(DOC_IDREF(fmprint_pkt)()),
except they print to CODE(stdout), and the layers are specified
differently.
For CODE(DOC_ID(mprint_pkt)()), VAR(layerp) is a pointer
to an array of two integers containing
VAR(minlayer) and VAR(maxlayer).
For CODE(DOC_ID(print_pkt)()), VAR(layerp) is a pointer
to a single integer containing VAR(maxlayer);
VAR(minlayer) defaults to 1.
The odd syntax for specifying layers makes these functions
suitable for use as a
DOC_IDREF(pkt_handler) for
DOC_IDREF(read_pkts)().
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(int coral_fmt_if_subif, char *buf, DOC_TYPEREF(Iface) *iface,
    uint32_t subif)
:>,<:
DOC_DECL(fmt_if_subif, SCALAR iface, NUM subif)
:>)
<p>
CODE(DOC_ID(fmt_if_subif)) DOC_BOTH(prints, returns) a formatted
representation of VAR(iface) id and VAR(subif) DOC_C(into VAR(buf)).
DOC_C(<:
The size of VAR(buf) should be at least
CODE(DOC_CORAL(FMT_IF_SUBIF_LEN)).
:>)
If the data link type of VAR(iface) does not have subinterfaces,
the format is just the interface number
(DOC_IDREF(interface_get_number));
if it does, the format is
"VAR(if)[VAR(subif)]", where VAR(subif) is formatted as by
CODE(DOC_IDREF(fmt_subif)()).
DOC_C(This function returns the length of the formatted string.)
</p>

DOC_ENTRY(<:
DOC_DECL(int coral_fmt_subif, char *buf, DOC_TYPEREF(Iface) *iface,
    uint32_t subif)
:>,<:
DOC_DECL(fmt_subif, SCALAR iface, NUM subif)
:>)
<p>
CODE(DOC_ID(fmt_subif)) DOC_BOTH(prints, returns) a formatted
representation of VAR(subif)DOC_C( into VAR(buf)).
DOC_C(<:
The size of VAR(buf) should be at least
CODE(DOC_CORAL(FMT_SUBIF_LEN)).
:>)
The format depends on the data link type of VAR(iface):
</p>
<ul>
<li>ATM: "VAR(vp):VAR(vc)"</li>
<li>IEEE 802.3/Ethernet: "VAR(vlan_id)"</li>
<li>other: ""</li>
</ul>
DOC_C(<:
<p>
This function returns the length of the formatted string.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(void coral_dump, const DOC_TYPEREF(Source) *src)
DOC_DECL(void coral_dump_all, void)
:>,<:
DOC_DECL(dump, SCALAR src)
DOC_DECL(dump_all, )
:>)
<p>
Prints information about the indicated sources to the CoralReef DOC_REF(errfile, #DOC_ID(get_errfile)),
like the application DOC_APP(crl_info).
</p>

DOC_ENTRY(<:
DOC_DECL(void coral_stats, const DOC_TYPEREF(Source) *src)
DOC_DECL(void coral_stats_all, void)
:>,<:
DOC_DECL(stats, SCALAR src)
DOC_DECL(stats_all, )
:>)
<p>
Prints statistics about the indicated sources to the CoralReef DOC_REF(errfile, #DOC_ID(get_errfile)).
</p>

</dl>

DOC_C(<:
DOC_H3(Binary I/O, binary-io)
<dl>

DOC_ENTRY(<:
DOC_DECL(size_t coral_fwrite_binint, FILE *file, uint8_t *p)
m4_define(<:DOC_NOTOC:>, m4_incr(DOC_NOTOC))dnl Don't repeat func name in ToC
DOC_DECL(size_t coral_fwrite_binint, FILE *file, uint16_t *p)
DOC_DECL(size_t coral_fwrite_binint, FILE *file, uint32_t *p)
DOC_DECL(size_t coral_fwrite_binint, FILE *file, uint64_t *p)
m4_define(<:DOC_NOTOC:>, m4_decr(DOC_NOTOC))dnl
:>)
<p>
CODE(DOC_IDREF(fwrite_binint)) writes integer *VAR(p) to file VAR(file)
as an opaque but portable binary value.
If *VAR(p) is of type uint8_t, uint16_t, or uint32_t, it will be written
straightforwardly in network byte order.
But if *VAR(p) is uint64_t, its value must be less than 2<sup>62</sup>,
and it will it will be written in a compressed format that occupies only
1 byte if the value < 2<sup>6</sup>,
or 2 bytes if the value < 2<sup>14</sup>,
or 4 bytes if the value < 2<sup>30</sup>,
or 8 bytes otherwise.
This can result in a significant space saving in applications that need to
support values up to 2<sup>62</sup> - 1 even though the values are frequently
much smaller.
CODE(DOC_IDREF(fwrite_binint)) returns 1 if the integer was written
successfully, 0 otherwise.
CODE(DOC_IDREF(fwrite_binint)) is actually a macro.
</p>

DOC_ENTRY(<:
DOC_DECL(size_t coral_fread_binint, FILE *file, uint8_t *p)
m4_define(<:DOC_NOTOC:>, m4_incr(DOC_NOTOC))dnl Don't repeat func name in ToC
DOC_DECL(size_t coral_fread_binint, FILE *file, uint16_t *p)
DOC_DECL(size_t coral_fread_binint, FILE *file, uint32_t *p)
DOC_DECL(size_t coral_fread_binint, FILE *file, uint64_t *p)
m4_define(<:DOC_NOTOC:>, m4_decr(DOC_NOTOC))dnl
:>)
<p>
CODE(DOC_IDREF(fread_binint)) reads a binary integer written by
CODE(DOC_IDREF(fwrite_binint)) from VAR(file) and places its value
in *VAR(p).
The type of *VAR(p) must match the type used to write the integer with
CODE(DOC_IDREF(fwrite_binint)).
Like fread(), CODE(DOC_IDREF(fread_binint)) returns 1 if the integer was read
successfully, 0 otherwise; you can use
ferror(<var>file</var>) or feof(<var>file</var>)
to determine if a failure was due to error or end of file.
CODE(DOC_IDREF(fread_binint)) is actually a macro.
</p>

</dl>
:>)

DOC_H3(Other, other)
<dl>

DOC_ENTRY(<:
DOC_DECL(char *coral_filename, const char *str, char *dst, size_t len)
:>,<:
DOC_DECL(filename, STR str)
:>)
<p>
DOC_BOTH(<:
Copies VAR(str) to VAR(dst),
:>,<:
Returns a copy of VAR(str) 
:>)
with any leading "CODE(~name/)" replaced with the home directory of user
VAR(name), and any leading "~/" replaced with the home directory of the user
who owns the process.
DOC_C(<:
At most CODE(VAR(len) - 1) characters will be written into
VAR(dst).  (A typical value for VAR(len) is CODE(PATH_MAX),
defined in CODE(&lt;limits.h&gt;).)
If VAR(dst) is CODE(DOC_NULL),
DOC_IDREF(filename)()
will malloc VAR(len) bytes for it before writing to it.  It is the
caller's responsibility to free the allocated memory.
The return value is a pointer to the buffer containing the expanded filename,
or CODE(DOC_NULL) if DOC_IDREF(filename)()
could not allocate the required memory.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
#include &lt;sys/types.h&gt;<br />
#include &lt;sys/socket.h&gt;<br />
DOC_DECL(int coral_inet_pton, int af, const char *src, void *dst)
:>)
<p>
Same as inet_pton(), for hosts that don't have inet_pton() or inet_aton().
(Note that inet_addr() is unable to distinguish between the IPv4 address
255.255.255.255 and an error.)
Converts an address string in VAR(src) to an internal form in
VAR(dst) according to the address family VAR(af).
Valid values for VAR(af) are AF_INET and AF_INET6.
</p>
:>)

DOC_C(<:
DOC_ENTRY(<:
#include &lt;arpa/inet.h&gt;<br />
DOC_DECL(int coral_inet_ntop, int af, const void *src, char *dst, int dstlen)
:>)
<p>
Same as inet_ntop(), for hosts that don't have inet_ntop() or inet_ntoa().
Converts an IPv4 or IPv6 address in VAR(src) to a string in
VAR(dst) according to the address family VAR(af).
Valid values for VAR(af) are AF_INET and AF_INET6.
</p>
:>)

DOC_ENTRY(<:
DOC_DECL(uint32_t coral_in_cksum_add, uint32_t psum, const void *data,
    int len)
DOC_DECL(uint16_t coral_in_cksum_result, uint32_t psum)
:>,<:
DOC_DECL(in_cksum_add, NUM psum, SCALAR data, NUM len)
DOC_DECL(in_cksum_result, NUM psum)
:>)
<p>
Calculates the internet checksum of the string in VAR(data).
Usage:
</p>
<ol>
<li>initialize CODE(psum) to 0</li>
<li>call CODE(DOC_VAR(psum) =
    DOC_IDREF(in_cksum_add)(DOC_VAR(psum), VAR(data), VAR(len)))
    for each segment of buffer,
    where VAR(data) is DOC_C(a pointer to )the segment
    and VAR(len) is the length of the segment</li>
<li>call CODE(DOC_IDREF(in_cksum_result)(DOC_VAR(psum)))
    to get result.</li>
</ol>
<p>
Segments must be short-aligned.
Entire message must have length less than 32768.
</p>

DOC_C(<:
DOC_ENTRY(<:
DOC_DECL(int coral_sendblk, DOC_TYPEREF(Source) *src, int ndesc)
:>)
<p>
Incomplete.
</p>
:>)

</dl>

DOC_BOTH(
<:
DOC_H3(Types, types)
<p>
The definitions here are not necessarily complete; actual structures may
contain undocumented fields that should not be accessed by the programmer.
</p>
:>,
<:
DOC_H3(Classes, classes)
:>)

<dl>

DOC_C(<:
<dt>
DOC_LABEL(int8_t, uint8_t, int16_t, uint16_t,
    int32_t, uint32_t, int64_t, uint64_t)
ANSI/ISO C fixed width integer types
<dd>
<code>
<b>int8_t</b>, <b>int16_t</b>, <b>int32_t</b>, <b>int64_t</b>,<br />
<b>uint8_t</b>, <b>uint16_t</b>, <b>uint32_t</b>, <b>uint64_t</b>
</code>
<p>
If these are not already defined on your platform,
CODE(&lt;libcoral.h&gt;) will define them.
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Source))
<dt><b>DOC_TYPE(Source)</b> - Coral Source
<dd>
<p>
An opaque structure representing a source of network traffic:  either a
tracefile or a real network device.
See the DOC_REF(Introduction, #intro).
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Iface))
<dt><b>DOC_TYPE(Iface)</b> - Coral Interface
<dd>
<p>
An opaque structure representing a single network device within a source
(since a tracefile may contain data from multiple devices).
See the DOC_REF(Introduction, #intro).
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(io_mode))
<dt><b>DOC_TYPE(io_mode)</b> - I/O Mode
<dd>
<p>
The <b>DOC_TYPE(io_mode)</b> structure describes device options.
See DOC_IDREF(set_iomode) for a description of the possible flag values.
</p>
<pre>
typedef struct {
    u_int   flags;      /* options */
    int     first_n;    /* number of bytes to read per packet */
} <b>DOC_TYPE(io_mode)</b>;
</pre>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Writer))
<dt><b>DOC_TYPE(Writer)</b> - Coral Writer
<dd>
<p>
An opaque structure representing a file to which the
DOC_IDREF(write) functions will write.
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Timestamp))
<dt><b>DOC_TYPE(Timestamp)</b> - Coral Timestamp
<dd>
<p>
An opaque interface-specific timestamp format that should be accessed through
the DOC_IDREF(read_clock) functions.
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Protocol))
<dt><b>DOC_TYPE(Protocol)</b> - Coral Protocol
<dd>
<p>
A protocol identifier.  See the
DOC_CMD_USAGE(protocols, #protocols) section of the
DOC_CMD_USAGE(Command Usage) document.
</p>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(Blk_info))
<dt><b>DOC_TYPE(Blk_info)</b> - ATM block info
<dd>
<p>
The <b>DOC_TYPE(Blk_info)</b> structure defined in CODE(&lt;libcoral.h&gt;)
is used by many functions.  All members are in network byte order.
It has at least these members:
</p>
<pre>
    u_int               interface;      /* which card this came from, if 
                                         * applicable */
    u_int               blk_size;       /* number of bytes in block */
    u_int               cell_count;     /* number of valid cells in this blk */
    u_int               cells_lost;     /* number of cells lost during block */
    u_int               unknown_vpi_vci;/* cells dropped because vpi/vci 
                                         * unknown */
    struct timespec     tbegin;         /* time of block start */
    struct timespec     tend;           /* time of block end */
</pre>
<p>
Note that the CODE(interface) field may not correspond to
the number of the VAR(iface) pointer returned by the
CoralReef reading functions.
</p>
:>)

DOC_C(<:
DOC_LABEL(atm_hdr)
<dt><b>atm_hdr</b> - ATM header
<dd>
<p>
The CODE(atm_hdr.h) structure will only be available if
CODE(BYTE_ORDER) or CODE(WORDS_BIGENDIAN) is defined
when CODE(&lt;libcoral.h&gt;) is included.
(CODE(BYTE_ORDER) is defined in CODE(&lt;sys/param.h&gt;)
on some platforms,
and CODE(WORDS_BIGENDIAN) can be defined by a GNU configure script.)
The programmer must ensure that CODE(atm_hdr.ui) is in host byte order
before accessing fields of CODE(atm_hdr.h).
</p>
<pre>
union <b>atm_hdr</b> {
    struct {
        uint32_t gfc        : 4;  /* generic flow control */
        uint32_t vpvc       : 24; /* virtual path + circuit indicators */
        uint32_t oam_rm     : 1;  /* PTI: OAM/RM indicator (ie, not user data) */
        uint32_t congestion : 1;  /* PTI: we don't use this */
        uint32_t sdu_type   : 1;  /* PTI: in AAL5, this marks end of SAR-SDU */
        uint32_t clp        : 1;  /* cell loss priority */
    } h;
    uint32_t ui;
};
</pre>
:>)

DOC_C(<:
DOC_LABEL(DOC_TYPE(atm_cell))
<dt><b>DOC_TYPE(atm_cell)</b> - ATM cell
<dd>
<p>
As of version 3.3, the ATM cell record structure is not directly accessible;
CODE(DOC_TYPE(atm_cell)) is just CODE(void).
All access to the fields of a cell record must be done with the
accessor functions below.  This is so libcoral can support different record
layouts used by different hardware, firmware, and drivers.
</p>
<p>
Any of the accessors that return a pointer may return CODE(DOC_NULL)
if the field is not available because of hardware, firmware, or driver options.
</p>
<p>
The VAR(iface) parameter of each accessor macro must be the interface
from which VAR(cell) was read.
</p>
<dl>
DOC_LABEL(DOC_ID(cell_time))
DOC_ENTRY_NOTOC(<:
    DOC_DECL(const DOC_TYPEREF(Timestamp) *coral_cell_time,
	VAR(iface), VAR(cell))
:>)
    Returns a pointer to the timestamp of VAR(cell), in an
    interface-specific format that should be accessed through the
    DOC_IDREF(read_clock) functions.
DOC_LABEL(DOC_ID(cell_header))
DOC_ENTRY_NOTOC(<:
    DOC_DECL(const union atm_hdr *coral_cell_header,
	VAR(iface), VAR(cell))
:>)
    Returns a pointer to the first 4 bytes (containing VPI, VCI, PTI, CLP)
    of the ATM header of VAR(cell) (in network byte order).
DOC_LABEL(DOC_ID(cell_hec))
DOC_ENTRY_NOTOC(<:
    DOC_DECL(const char *coral_cell_hec, VAR(iface), VAR(cell))
:>)
    Returns a pointer to the Header Error Control byte of the ATM header of
    VAR(cell).
DOC_LABEL(DOC_ID(cell_payload))
DOC_ENTRY_NOTOC(<:
    DOC_DECL(const char *coral_cell_payload, VAR(iface), VAR(cell))
:>)
    Returns a pointer to the 48-byte payload of VAR(cell).
DOC_LABEL(DOC_ID(cell_size))
DOC_ENTRY_NOTOC(<:
    DOC_DECL(size_t coral_cell_size, VAR(iface))
:>)
    Returns the size of the cell structure used by VAR(iface).
</dl>
<p>
VAR(Iface) is a CODE((DOC_TYPEREF(Iface) *)) pointing to the interface
from which VAR(cell) was read.  VAR(Cell) is a
CODE((DOC_TYPE(atm_cell) *)) pointing to the cell record from which the
field will be read.  Any of the accessor functions that return a pointer may
return CODE(DOC_NULL) if the corresponding field is not present in the cell
structure for the given interface.
</p>
<p>
The old version of the structure is documented here for reference only.
</p>
<pre>
typedef struct {
    DOC_TYPEREF(Timestamp) t;	/* timestamp, in card-specific format */
    union DOC_REF(atm_hdr, #atm_hdr) cu;		/* ATM header (without HEC) */
    union {
	char payload[48];
	short payload_shorts[24];
	u_int payload_i[12];
    } p;			/* ATM cell payload == SAR-PDU */
} <b>DOC_TYPE(atm_cell)</b>; /* obsolete - for reference only */
</pre>
:>)

DOC_PERL(<:
<dt>
DOC_LABEL(DOC_TYPE(Cell))
<b>DOC_TYPE(Cell)</b>
<dd>
<p>
This class is returned by a call to one of the DOC_IDREF(read_cell) functions,
representing a cell and its members.
All member functions require the interface as an argument, e.g.:
</p>
<pre>
    $header = $cell-&gt;header($iface);
</pre>
<p>
This header (or the payload) can then be parsed with the
DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
The DOC_TYPE(Cell) member functions are:
</p>
<pre>
    SCALAR timestamp	# time cell was read (interpret with DOC_IDREF(read_clock) functions)
    STR header		# link layer header (e.g., ATM)
    STR hec		# HEC that libcoral doesn't include in the header
    STR payload		# link or sub-network layer packet
</pre>
:>)

DOC_C(<:
<dt>
DOC_LABEL(aal5_trailer_t)
<b>aal5_trailer_t</b> - ATM AAL5 trailer
<dd>
<pre>
typedef struct {
    uint8_t	cpcs_uu;	/* CPCS user-to-user indication */
    uint8_t	cpi;		/* common part indicator */
    uint16_t	length;		/* length of CPCS PDU payload */
    uint32_t	crc;		/* cyclic redundancy check of CPCS PDU */
} <b>aal5_trailer_t</b>;
</pre>
:>)

DOC_C(<:
<dt>
DOC_LABEL(DOC_TYPE(llcsnap))
<b>DOC_TYPE(llcsnap)</b> - LLC/SNAP header (IEEE 802.2 and rfc1042)
<dd>
<pre>
typedef struct {
    uint8_t	llc_dsap;
    uint8_t	llc_ssap;
    uint8_t	llc_cntl;
    uint8_t	snap_org[3];
    uint16_t	snap_type;
} <b>DOC_TYPE(llcsnap)</b>;
</pre>
:>)

<dt>
DOC_LABEL(DOC_TYPE(Pkt_buffer))
<b>DOC_TYPE(Pkt_buffer)</b> - Buffer structure for packet API
<dd>
<pre>DOC_BOTH(<:
typedef struct {
    int caplen;			/* length of data actually captured in buf */
    int totlen;			/* total length of pkt (negative if unknown) */
    const char *buf;		/* data (aligned to a multiple of 4 bytes) */
    DOC_TYPEREF(Protocol) protocol;	/* DOC_CMD_USAGE(protocol, #protocols) */
    ...
} <b>DOC_TYPE(Pkt_buffer)</b>;
:>, <:
    NUM caplen		# length of data actually captured in buf
    NUM totlen		# total length of pkt (negative if unknown)
    STR buf		# data (in a byte-string format)
    NUM protocol	# protocol (ie, what kind of buffer is this?)

The byte string in CODE(buf) can be parsed by the DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
:>)</pre>

<dt>
DOC_LABEL(DOC_TYPE(Pkt_stats))
<b>DOC_TYPE(Pkt_stats)</b> - Statistics for packet API
<dd>
<pre>DOC_C(<:
typedef struct {
:>)dnl
    DOC_uint64 l2_recv;           DOC_COM(Layer 2 PDUs received)
    DOC_uint64 l2_drop;           DOC_COM(Layer 2 PDUs dropped)
    DOC_uint64 pkts_recv;         DOC_COM(packets received)
    DOC_uint64 pkts_drop;         DOC_COM(packets dropped)
    DOC_uint64 truncated;         DOC_COM(packets truncated by insufficient capture)
    DOC_uint64 driver_corrupt;    DOC_COM(cell looks bad from the capture device)
    DOC_uint64 too_many_vpvc;     DOC_COM(too many simultaneous vpvc pairs)
    DOC_uint64 buffer_overflow;   DOC_COM(AAL5 cell stream &gt; MAX_PACKET_SIZE)
    DOC_uint64 aal5_trailer;      DOC_COM(AAL5 trailer had bad length)
    DOC_uint64 ok_packet;
DOC_C(
<:} <b>DOC_TYPE(Pkt_stats)</b>;
:>)dnl
</pre>
<p>
The CODE(l2_recv) and CODE(l2_drop) fields count layer 2 PDUs
(e.g., ATM cells), and may not be totally accurate.
On interfaces that operate on blocks (i.e., POINT, FORE ATM, and DAG),
the layer 2 PDUs reported are those belonging to every block that started
within the interval.  If there are many blocks per interval the error should
be small, but if traffic is low the error is more significant.
DOC_C(<:
If you require more accurate per-block data, use
DOC_IDREF(cell_block_hook).
:>)
<p>
Most types of interfaces set only a subset of these statistics
(the rest will always be zero):
<dl>
<dt>ATM interfaces
    <dd>
    CODE(l2_recv),
    CODE(l2_drop),
    CODE(pkts_recv),
    CODE(truncated),
    CODE(driver_corrupt),
    CODE(too_many_vpvc),
    CODE(buffer_overflow),
    CODE(aal5_trailer)
<dt>non-ATM DAG interfaces
    <dd>
    CODE(pkts_recv),
    CODE(pkts_drop),
    CODE(truncated)
<dt>live pcap interfaces
    <dd>
    CODE(pkts_recv),
    CODE(pkts_drop)
    (see also DOC_REF(dropinterval, #DOC_ID(set_dropinterval)))
<dt>pcap tracefiles
    <dd>none
<dt>TSH files
    <dd>
    CODE(pkts_recv),
    CODE(truncated)
</dl>
</p>

<dt>
DOC_LABEL(DOC_TYPE(Pkt_result))
<b>DOC_TYPE(Pkt_result)</b> - Packet results for packet API
<dd>
<pre>DOC_BOTH(<:
typedef struct {
    const DOC_TYPEREF(Timestamp) *timestamp; /* time packet was read */
    DOC_TYPEREF(Pkt_buffer) *packet;         /* link or sub-network layer packet */
    DOC_TYPEREF(Pkt_buffer) *header;         /* link layer header (eg, ATM) */
    DOC_TYPEREF(Pkt_buffer) *trailer;        /* link layer trailer (eg, AAL5) */
    uint32_t subiface;       /* sub-interface id (ATM VPVC or VLAN ID) */
} <b>DOC_TYPE(Pkt_result)</b>;
:>, <:
    SCALAR timestamp	# time packet was read (interpret with DOC_IDREF(read_clock) functions)
    DOC_TYPEREF(Pkt_buffer) packet	# link or sub-network layer packet
    DOC_TYPEREF(Pkt_buffer) header	# link layer header (eg, ATM)
    DOC_TYPEREF(Pkt_buffer) trailer	# link layer trailer (eg, AAL5)
    NUM subiface	# sub-interface id (ATM VPVC or VLAN ID)
:>)</pre>
<p>
The CODE(subiface) field can be formatted with
DOC_IDREF(fmt_subif)().
</p>

<dt>
DOC_LABEL(DOC_TYPE(Interval_result))
<b>DOC_TYPE(Interval_result)</b> - Interval results for packet API
<dd>
<pre>DOC_BOTH(<:
typedef struct {
    struct timeval begin;               /* beginning of interval */
    struct timeval end;                 /* end of interval */
    DOC_TYPEREF(Pkt_stats) *stats;           /* packet statistics for interval */
} <b>DOC_TYPE(Interval_result)</b>;
:>, <:
    LIST begin		# beginning of interval (sec, usec)
    LIST end		# end of interval (sec, usec)
    DOC_TYPEREF(Pkt_stats) stats	# statistics for interval
:>)</pre>

<dt>
DOC_LABEL(DOC_TYPE(Rotfile))
<b>DOC_TYPE(Rotfile)</b> - DOC_REF(Rotating, #DOC_ID(rotfile)) file handle
<dd>
<p>
An opaque structure that should be accessed through
the DOC_REF(DOC_ID(rf_*), #DOC_ID(rotfile)) functions.
</p>

DOC_C(<:

<dt>
DOC_LABEL(DOC_TYPE(rf_info_gz))
<b>DOC_TYPE(rf_info_gz)</b> - data for DOC_REF(rotating, #DOC_ID(rotfile)) gzFile
<dd>
<pre>
typedef struct {
    const char *gzmode;
    void *gzfile;
} <b>DOC_TYPE(rf_info_gz)</b>;
</pre>

<dt>
DOC_LABEL(DOC_TYPE(rf_info_ogz))
<b>DOC_TYPE(rf_info_ogz)</b> - data for DOC_REF(rotating, #DOC_ID(rotfile)) optionally-gzipped file
<dd>
<p>
</p>

<dt>
DOC_LABEL(DOC_TYPE(rf_info_pcap_dump))
<b>DOC_TYPE(rf_info_pcap_dump)</b> - data for DOC_REF(rotating, #DOC_ID(rotfile)) pcap_dumper
<dd>
<pre>
typedef struct {
    pcap_dumper_t *pcap_dumper;
    pcap_t *pcap;
} <b>DOC_TYPE(rf_info_pcap_dump)</b>;
</pre>

:>)

</dl>

</body>
</html>

m4_divert(1)dnl Table of Contents
DOC_SET_TOC_DEPTH(1)dnl end the <ul>'s

